// Code generated by go-swagger; DO NOT EDIT.

// (c) 2012-2023 by Vernon Keenan
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package attendees

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"
)

// New creates a new attendees API client.
func New(transport runtime.ClientTransport, formats strfmt.Registry) ClientService {
	return &Client{transport: transport, formats: formats}
}

/*
Client for attendees API
*/
type Client struct {
	transport runtime.ClientTransport
	formats   strfmt.Registry
}

// ClientOption is the option for Client methods
type ClientOption func(*runtime.ClientOperation)

// ClientService is the interface for Client methods
type ClientService interface {
	GetAttendees(params *GetAttendeesParams, authInfo runtime.ClientAuthInfoWriter, opts ...ClientOption) (*GetAttendeesOK, error)

	PostAttendees(params *PostAttendeesParams, authInfo runtime.ClientAuthInfoWriter, opts ...ClientOption) (*PostAttendeesOK, error)

	PutAttendees(params *PutAttendeesParams, authInfo runtime.ClientAuthInfoWriter, opts ...ClientOption) (*PutAttendeesOK, error)

	SetTransport(transport runtime.ClientTransport)
}

/*
GetAttendees gets a list attendees

Return a list of Attendee records from the datastore
*/
func (a *Client) GetAttendees(params *GetAttendeesParams, authInfo runtime.ClientAuthInfoWriter, opts ...ClientOption) (*GetAttendeesOK, error) {
	// TODO: Validate the params before sending
	if params == nil {
		params = NewGetAttendeesParams()
	}
	op := &runtime.ClientOperation{
		ID:                 "getAttendees",
		Method:             "GET",
		PathPattern:        "/attendees",
		ProducesMediaTypes: []string{"application/json"},
		ConsumesMediaTypes: []string{"application/json"},
		Schemes:            []string{"http"},
		Params:             params,
		Reader:             &GetAttendeesReader{formats: a.formats},
		AuthInfo:           authInfo,
		Context:            params.Context,
		Client:             params.HTTPClient,
	}
	for _, opt := range opts {
		opt(op)
	}

	result, err := a.transport.Submit(op)
	if err != nil {
		return nil, err
	}
	success, ok := result.(*GetAttendeesOK)
	if ok {
		return success, nil
	}
	// unexpected success response
	// safeguard: normally, absent a default response, unknown success responses return an error above: so this is a codegen issue
	msg := fmt.Sprintf("unexpected success response for getAttendees: API contract not enforced by server. Client expected to get an error, but got: %T", result)
	panic(msg)
}

/*
PostAttendees creates new attendees

Create Attendees
*/
func (a *Client) PostAttendees(params *PostAttendeesParams, authInfo runtime.ClientAuthInfoWriter, opts ...ClientOption) (*PostAttendeesOK, error) {
	// TODO: Validate the params before sending
	if params == nil {
		params = NewPostAttendeesParams()
	}
	op := &runtime.ClientOperation{
		ID:                 "postAttendees",
		Method:             "POST",
		PathPattern:        "/attendees",
		ProducesMediaTypes: []string{"application/json"},
		ConsumesMediaTypes: []string{"application/json"},
		Schemes:            []string{"http"},
		Params:             params,
		Reader:             &PostAttendeesReader{formats: a.formats},
		AuthInfo:           authInfo,
		Context:            params.Context,
		Client:             params.HTTPClient,
	}
	for _, opt := range opts {
		opt(op)
	}

	result, err := a.transport.Submit(op)
	if err != nil {
		return nil, err
	}
	success, ok := result.(*PostAttendeesOK)
	if ok {
		return success, nil
	}
	// unexpected success response
	// safeguard: normally, absent a default response, unknown success responses return an error above: so this is a codegen issue
	msg := fmt.Sprintf("unexpected success response for postAttendees: API contract not enforced by server. Client expected to get an error, but got: %T", result)
	panic(msg)
}

/*
PutAttendees updates attendee

Update Attendee
*/
func (a *Client) PutAttendees(params *PutAttendeesParams, authInfo runtime.ClientAuthInfoWriter, opts ...ClientOption) (*PutAttendeesOK, error) {
	// TODO: Validate the params before sending
	if params == nil {
		params = NewPutAttendeesParams()
	}
	op := &runtime.ClientOperation{
		ID:                 "putAttendees",
		Method:             "PUT",
		PathPattern:        "/attendees",
		ProducesMediaTypes: []string{"application/json"},
		ConsumesMediaTypes: []string{"application/json"},
		Schemes:            []string{"http"},
		Params:             params,
		Reader:             &PutAttendeesReader{formats: a.formats},
		AuthInfo:           authInfo,
		Context:            params.Context,
		Client:             params.HTTPClient,
	}
	for _, opt := range opts {
		opt(op)
	}

	result, err := a.transport.Submit(op)
	if err != nil {
		return nil, err
	}
	success, ok := result.(*PutAttendeesOK)
	if ok {
		return success, nil
	}
	// unexpected success response
	// safeguard: normally, absent a default response, unknown success responses return an error above: so this is a codegen issue
	msg := fmt.Sprintf("unexpected success response for putAttendees: API contract not enforced by server. Client expected to get an error, but got: %T", result)
	panic(msg)
}

// SetTransport changes the transport on the client
func (a *Client) SetTransport(transport runtime.ClientTransport) {
	a.transport = transport
}
