// Code generated by go-swagger; DO NOT EDIT.

// (c) 2012-2023 by Vernon Keenan
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package courses

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"

	"code.tnxs.net/work/lib/api/members/members_models"
)

// NewPostCourseLessonsParams creates a new PostCourseLessonsParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewPostCourseLessonsParams() *PostCourseLessonsParams {
	return &PostCourseLessonsParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewPostCourseLessonsParamsWithTimeout creates a new PostCourseLessonsParams object
// with the ability to set a timeout on a request.
func NewPostCourseLessonsParamsWithTimeout(timeout time.Duration) *PostCourseLessonsParams {
	return &PostCourseLessonsParams{
		timeout: timeout,
	}
}

// NewPostCourseLessonsParamsWithContext creates a new PostCourseLessonsParams object
// with the ability to set a context for a request.
func NewPostCourseLessonsParamsWithContext(ctx context.Context) *PostCourseLessonsParams {
	return &PostCourseLessonsParams{
		Context: ctx,
	}
}

// NewPostCourseLessonsParamsWithHTTPClient creates a new PostCourseLessonsParams object
// with the ability to set a custom HTTPClient for a request.
func NewPostCourseLessonsParamsWithHTTPClient(client *http.Client) *PostCourseLessonsParams {
	return &PostCourseLessonsParams{
		HTTPClient: client,
	}
}

/*
PostCourseLessonsParams contains all the parameters to send to the API endpoint

	for the post course lessons operation.

	Typically these are written to a http.Request.
*/
type PostCourseLessonsParams struct {

	/* CourselessonRequest.

	   An array of new CourseLesson records
	*/
	CourselessonRequest *members_models.CourseLessonRequest

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the post course lessons params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *PostCourseLessonsParams) WithDefaults() *PostCourseLessonsParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the post course lessons params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *PostCourseLessonsParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the post course lessons params
func (o *PostCourseLessonsParams) WithTimeout(timeout time.Duration) *PostCourseLessonsParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the post course lessons params
func (o *PostCourseLessonsParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the post course lessons params
func (o *PostCourseLessonsParams) WithContext(ctx context.Context) *PostCourseLessonsParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the post course lessons params
func (o *PostCourseLessonsParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the post course lessons params
func (o *PostCourseLessonsParams) WithHTTPClient(client *http.Client) *PostCourseLessonsParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the post course lessons params
func (o *PostCourseLessonsParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithCourselessonRequest adds the courselessonRequest to the post course lessons params
func (o *PostCourseLessonsParams) WithCourselessonRequest(courselessonRequest *members_models.CourseLessonRequest) *PostCourseLessonsParams {
	o.SetCourselessonRequest(courselessonRequest)
	return o
}

// SetCourselessonRequest adds the courselessonRequest to the post course lessons params
func (o *PostCourseLessonsParams) SetCourselessonRequest(courselessonRequest *members_models.CourseLessonRequest) {
	o.CourselessonRequest = courselessonRequest
}

// WriteToRequest writes these params to a swagger request
func (o *PostCourseLessonsParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error
	if o.CourselessonRequest != nil {
		if err := r.SetBodyParam(o.CourselessonRequest); err != nil {
			return err
		}
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
