// Code generated by go-swagger; DO NOT EDIT.

// (c) 2012-2023 by Vernon Keenan
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package courses

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"

	"code.tnxs.net/work/lib/api/members/members_models"
)

// NewUpdateCoursesParams creates a new UpdateCoursesParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewUpdateCoursesParams() *UpdateCoursesParams {
	return &UpdateCoursesParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewUpdateCoursesParamsWithTimeout creates a new UpdateCoursesParams object
// with the ability to set a timeout on a request.
func NewUpdateCoursesParamsWithTimeout(timeout time.Duration) *UpdateCoursesParams {
	return &UpdateCoursesParams{
		timeout: timeout,
	}
}

// NewUpdateCoursesParamsWithContext creates a new UpdateCoursesParams object
// with the ability to set a context for a request.
func NewUpdateCoursesParamsWithContext(ctx context.Context) *UpdateCoursesParams {
	return &UpdateCoursesParams{
		Context: ctx,
	}
}

// NewUpdateCoursesParamsWithHTTPClient creates a new UpdateCoursesParams object
// with the ability to set a custom HTTPClient for a request.
func NewUpdateCoursesParamsWithHTTPClient(client *http.Client) *UpdateCoursesParams {
	return &UpdateCoursesParams{
		HTTPClient: client,
	}
}

/*
UpdateCoursesParams contains all the parameters to send to the API endpoint

	for the update courses operation.

	Typically these are written to a http.Request.
*/
type UpdateCoursesParams struct {

	/* CourseRequest.

	   An array of new Course records
	*/
	CourseRequest *members_models.CourseRequest

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the update courses params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *UpdateCoursesParams) WithDefaults() *UpdateCoursesParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the update courses params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *UpdateCoursesParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the update courses params
func (o *UpdateCoursesParams) WithTimeout(timeout time.Duration) *UpdateCoursesParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the update courses params
func (o *UpdateCoursesParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the update courses params
func (o *UpdateCoursesParams) WithContext(ctx context.Context) *UpdateCoursesParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the update courses params
func (o *UpdateCoursesParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the update courses params
func (o *UpdateCoursesParams) WithHTTPClient(client *http.Client) *UpdateCoursesParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the update courses params
func (o *UpdateCoursesParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithCourseRequest adds the courseRequest to the update courses params
func (o *UpdateCoursesParams) WithCourseRequest(courseRequest *members_models.CourseRequest) *UpdateCoursesParams {
	o.SetCourseRequest(courseRequest)
	return o
}

// SetCourseRequest adds the courseRequest to the update courses params
func (o *UpdateCoursesParams) SetCourseRequest(courseRequest *members_models.CourseRequest) {
	o.CourseRequest = courseRequest
}

// WriteToRequest writes these params to a swagger request
func (o *UpdateCoursesParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error
	if o.CourseRequest != nil {
		if err := r.SetBodyParam(o.CourseRequest); err != nil {
			return err
		}
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
