// Code generated by go-swagger; DO NOT EDIT.

// (c) 2012-2023 by Vernon Keenan
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package emails

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"

	"code.tnxs.net/work/lib/api/members/members_models"
)

// NewPostEmailMessagesParams creates a new PostEmailMessagesParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewPostEmailMessagesParams() *PostEmailMessagesParams {
	return &PostEmailMessagesParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewPostEmailMessagesParamsWithTimeout creates a new PostEmailMessagesParams object
// with the ability to set a timeout on a request.
func NewPostEmailMessagesParamsWithTimeout(timeout time.Duration) *PostEmailMessagesParams {
	return &PostEmailMessagesParams{
		timeout: timeout,
	}
}

// NewPostEmailMessagesParamsWithContext creates a new PostEmailMessagesParams object
// with the ability to set a context for a request.
func NewPostEmailMessagesParamsWithContext(ctx context.Context) *PostEmailMessagesParams {
	return &PostEmailMessagesParams{
		Context: ctx,
	}
}

// NewPostEmailMessagesParamsWithHTTPClient creates a new PostEmailMessagesParams object
// with the ability to set a custom HTTPClient for a request.
func NewPostEmailMessagesParamsWithHTTPClient(client *http.Client) *PostEmailMessagesParams {
	return &PostEmailMessagesParams{
		HTTPClient: client,
	}
}

/*
PostEmailMessagesParams contains all the parameters to send to the API endpoint

	for the post email messages operation.

	Typically these are written to a http.Request.
*/
type PostEmailMessagesParams struct {

	/* EmailMessageRequest.

	   An array of Email Message records
	*/
	EmailMessageRequest *members_models.EmailMessageRequest

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the post email messages params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *PostEmailMessagesParams) WithDefaults() *PostEmailMessagesParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the post email messages params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *PostEmailMessagesParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the post email messages params
func (o *PostEmailMessagesParams) WithTimeout(timeout time.Duration) *PostEmailMessagesParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the post email messages params
func (o *PostEmailMessagesParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the post email messages params
func (o *PostEmailMessagesParams) WithContext(ctx context.Context) *PostEmailMessagesParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the post email messages params
func (o *PostEmailMessagesParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the post email messages params
func (o *PostEmailMessagesParams) WithHTTPClient(client *http.Client) *PostEmailMessagesParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the post email messages params
func (o *PostEmailMessagesParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithEmailMessageRequest adds the emailMessageRequest to the post email messages params
func (o *PostEmailMessagesParams) WithEmailMessageRequest(emailMessageRequest *members_models.EmailMessageRequest) *PostEmailMessagesParams {
	o.SetEmailMessageRequest(emailMessageRequest)
	return o
}

// SetEmailMessageRequest adds the emailMessageRequest to the post email messages params
func (o *PostEmailMessagesParams) SetEmailMessageRequest(emailMessageRequest *members_models.EmailMessageRequest) {
	o.EmailMessageRequest = emailMessageRequest
}

// WriteToRequest writes these params to a swagger request
func (o *PostEmailMessagesParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error
	if o.EmailMessageRequest != nil {
		if err := r.SetBodyParam(o.EmailMessageRequest); err != nil {
			return err
		}
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
