// Code generated by go-swagger; DO NOT EDIT.

// (c) 2012-2023 by Vernon Keenan
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package enrollments

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"

	"code.tnxs.net/work/lib/api/members/members_models"
)

// GetEnrollmentsReader is a Reader for the GetEnrollments structure.
type GetEnrollmentsReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *GetEnrollmentsReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewGetEnrollmentsOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 401:
		result := NewGetEnrollmentsUnauthorized()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 403:
		result := NewGetEnrollmentsForbidden()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 404:
		result := NewGetEnrollmentsNotFound()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 422:
		result := NewGetEnrollmentsUnprocessableEntity()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 500:
		result := NewGetEnrollmentsInternalServerError()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		return nil, runtime.NewAPIError("response status code does not match any response statuses defined for this endpoint in the swagger spec", response, response.Code())
	}
}

// NewGetEnrollmentsOK creates a GetEnrollmentsOK with default headers values
func NewGetEnrollmentsOK() *GetEnrollmentsOK {
	return &GetEnrollmentsOK{}
}

/*
GetEnrollmentsOK describes a response with status code 200, with default header values.

Enrollment Response Object
*/
type GetEnrollmentsOK struct {
	Payload *members_models.EnrollmentResponse
}

// IsSuccess returns true when this get enrollments o k response has a 2xx status code
func (o *GetEnrollmentsOK) IsSuccess() bool {
	return true
}

// IsRedirect returns true when this get enrollments o k response has a 3xx status code
func (o *GetEnrollmentsOK) IsRedirect() bool {
	return false
}

// IsClientError returns true when this get enrollments o k response has a 4xx status code
func (o *GetEnrollmentsOK) IsClientError() bool {
	return false
}

// IsServerError returns true when this get enrollments o k response has a 5xx status code
func (o *GetEnrollmentsOK) IsServerError() bool {
	return false
}

// IsCode returns true when this get enrollments o k response a status code equal to that given
func (o *GetEnrollmentsOK) IsCode(code int) bool {
	return code == 200
}

// Code gets the status code for the get enrollments o k response
func (o *GetEnrollmentsOK) Code() int {
	return 200
}

func (o *GetEnrollmentsOK) Error() string {
	return fmt.Sprintf("[GET /enrollments][%d] getEnrollmentsOK  %+v", 200, o.Payload)
}

func (o *GetEnrollmentsOK) String() string {
	return fmt.Sprintf("[GET /enrollments][%d] getEnrollmentsOK  %+v", 200, o.Payload)
}

func (o *GetEnrollmentsOK) GetPayload() *members_models.EnrollmentResponse {
	return o.Payload
}

func (o *GetEnrollmentsOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(members_models.EnrollmentResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetEnrollmentsUnauthorized creates a GetEnrollmentsUnauthorized with default headers values
func NewGetEnrollmentsUnauthorized() *GetEnrollmentsUnauthorized {
	return &GetEnrollmentsUnauthorized{}
}

/*
GetEnrollmentsUnauthorized describes a response with status code 401, with default header values.

Access Unauthorized, invalid API-KEY was used
*/
type GetEnrollmentsUnauthorized struct {
	Payload *members_models.Error
}

// IsSuccess returns true when this get enrollments unauthorized response has a 2xx status code
func (o *GetEnrollmentsUnauthorized) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this get enrollments unauthorized response has a 3xx status code
func (o *GetEnrollmentsUnauthorized) IsRedirect() bool {
	return false
}

// IsClientError returns true when this get enrollments unauthorized response has a 4xx status code
func (o *GetEnrollmentsUnauthorized) IsClientError() bool {
	return true
}

// IsServerError returns true when this get enrollments unauthorized response has a 5xx status code
func (o *GetEnrollmentsUnauthorized) IsServerError() bool {
	return false
}

// IsCode returns true when this get enrollments unauthorized response a status code equal to that given
func (o *GetEnrollmentsUnauthorized) IsCode(code int) bool {
	return code == 401
}

// Code gets the status code for the get enrollments unauthorized response
func (o *GetEnrollmentsUnauthorized) Code() int {
	return 401
}

func (o *GetEnrollmentsUnauthorized) Error() string {
	return fmt.Sprintf("[GET /enrollments][%d] getEnrollmentsUnauthorized  %+v", 401, o.Payload)
}

func (o *GetEnrollmentsUnauthorized) String() string {
	return fmt.Sprintf("[GET /enrollments][%d] getEnrollmentsUnauthorized  %+v", 401, o.Payload)
}

func (o *GetEnrollmentsUnauthorized) GetPayload() *members_models.Error {
	return o.Payload
}

func (o *GetEnrollmentsUnauthorized) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(members_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetEnrollmentsForbidden creates a GetEnrollmentsForbidden with default headers values
func NewGetEnrollmentsForbidden() *GetEnrollmentsForbidden {
	return &GetEnrollmentsForbidden{}
}

/*
GetEnrollmentsForbidden describes a response with status code 403, with default header values.

Access forbidden, account lacks access
*/
type GetEnrollmentsForbidden struct {
	AccessControlAllowOrigin string

	Payload *members_models.Error
}

// IsSuccess returns true when this get enrollments forbidden response has a 2xx status code
func (o *GetEnrollmentsForbidden) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this get enrollments forbidden response has a 3xx status code
func (o *GetEnrollmentsForbidden) IsRedirect() bool {
	return false
}

// IsClientError returns true when this get enrollments forbidden response has a 4xx status code
func (o *GetEnrollmentsForbidden) IsClientError() bool {
	return true
}

// IsServerError returns true when this get enrollments forbidden response has a 5xx status code
func (o *GetEnrollmentsForbidden) IsServerError() bool {
	return false
}

// IsCode returns true when this get enrollments forbidden response a status code equal to that given
func (o *GetEnrollmentsForbidden) IsCode(code int) bool {
	return code == 403
}

// Code gets the status code for the get enrollments forbidden response
func (o *GetEnrollmentsForbidden) Code() int {
	return 403
}

func (o *GetEnrollmentsForbidden) Error() string {
	return fmt.Sprintf("[GET /enrollments][%d] getEnrollmentsForbidden  %+v", 403, o.Payload)
}

func (o *GetEnrollmentsForbidden) String() string {
	return fmt.Sprintf("[GET /enrollments][%d] getEnrollmentsForbidden  %+v", 403, o.Payload)
}

func (o *GetEnrollmentsForbidden) GetPayload() *members_models.Error {
	return o.Payload
}

func (o *GetEnrollmentsForbidden) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header Access-Control-Allow-Origin
	hdrAccessControlAllowOrigin := response.GetHeader("Access-Control-Allow-Origin")

	if hdrAccessControlAllowOrigin != "" {
		o.AccessControlAllowOrigin = hdrAccessControlAllowOrigin
	}

	o.Payload = new(members_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetEnrollmentsNotFound creates a GetEnrollmentsNotFound with default headers values
func NewGetEnrollmentsNotFound() *GetEnrollmentsNotFound {
	return &GetEnrollmentsNotFound{}
}

/*
GetEnrollmentsNotFound describes a response with status code 404, with default header values.

Resource was not found
*/
type GetEnrollmentsNotFound struct {
	Payload *members_models.Error
}

// IsSuccess returns true when this get enrollments not found response has a 2xx status code
func (o *GetEnrollmentsNotFound) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this get enrollments not found response has a 3xx status code
func (o *GetEnrollmentsNotFound) IsRedirect() bool {
	return false
}

// IsClientError returns true when this get enrollments not found response has a 4xx status code
func (o *GetEnrollmentsNotFound) IsClientError() bool {
	return true
}

// IsServerError returns true when this get enrollments not found response has a 5xx status code
func (o *GetEnrollmentsNotFound) IsServerError() bool {
	return false
}

// IsCode returns true when this get enrollments not found response a status code equal to that given
func (o *GetEnrollmentsNotFound) IsCode(code int) bool {
	return code == 404
}

// Code gets the status code for the get enrollments not found response
func (o *GetEnrollmentsNotFound) Code() int {
	return 404
}

func (o *GetEnrollmentsNotFound) Error() string {
	return fmt.Sprintf("[GET /enrollments][%d] getEnrollmentsNotFound  %+v", 404, o.Payload)
}

func (o *GetEnrollmentsNotFound) String() string {
	return fmt.Sprintf("[GET /enrollments][%d] getEnrollmentsNotFound  %+v", 404, o.Payload)
}

func (o *GetEnrollmentsNotFound) GetPayload() *members_models.Error {
	return o.Payload
}

func (o *GetEnrollmentsNotFound) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(members_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetEnrollmentsUnprocessableEntity creates a GetEnrollmentsUnprocessableEntity with default headers values
func NewGetEnrollmentsUnprocessableEntity() *GetEnrollmentsUnprocessableEntity {
	return &GetEnrollmentsUnprocessableEntity{}
}

/*
GetEnrollmentsUnprocessableEntity describes a response with status code 422, with default header values.

Unprocessable Entity, likely a bad parameter
*/
type GetEnrollmentsUnprocessableEntity struct {
	Payload *members_models.Error
}

// IsSuccess returns true when this get enrollments unprocessable entity response has a 2xx status code
func (o *GetEnrollmentsUnprocessableEntity) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this get enrollments unprocessable entity response has a 3xx status code
func (o *GetEnrollmentsUnprocessableEntity) IsRedirect() bool {
	return false
}

// IsClientError returns true when this get enrollments unprocessable entity response has a 4xx status code
func (o *GetEnrollmentsUnprocessableEntity) IsClientError() bool {
	return true
}

// IsServerError returns true when this get enrollments unprocessable entity response has a 5xx status code
func (o *GetEnrollmentsUnprocessableEntity) IsServerError() bool {
	return false
}

// IsCode returns true when this get enrollments unprocessable entity response a status code equal to that given
func (o *GetEnrollmentsUnprocessableEntity) IsCode(code int) bool {
	return code == 422
}

// Code gets the status code for the get enrollments unprocessable entity response
func (o *GetEnrollmentsUnprocessableEntity) Code() int {
	return 422
}

func (o *GetEnrollmentsUnprocessableEntity) Error() string {
	return fmt.Sprintf("[GET /enrollments][%d] getEnrollmentsUnprocessableEntity  %+v", 422, o.Payload)
}

func (o *GetEnrollmentsUnprocessableEntity) String() string {
	return fmt.Sprintf("[GET /enrollments][%d] getEnrollmentsUnprocessableEntity  %+v", 422, o.Payload)
}

func (o *GetEnrollmentsUnprocessableEntity) GetPayload() *members_models.Error {
	return o.Payload
}

func (o *GetEnrollmentsUnprocessableEntity) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(members_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetEnrollmentsInternalServerError creates a GetEnrollmentsInternalServerError with default headers values
func NewGetEnrollmentsInternalServerError() *GetEnrollmentsInternalServerError {
	return &GetEnrollmentsInternalServerError{}
}

/*
GetEnrollmentsInternalServerError describes a response with status code 500, with default header values.

Server Internal Error
*/
type GetEnrollmentsInternalServerError struct {
	Payload *members_models.Error
}

// IsSuccess returns true when this get enrollments internal server error response has a 2xx status code
func (o *GetEnrollmentsInternalServerError) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this get enrollments internal server error response has a 3xx status code
func (o *GetEnrollmentsInternalServerError) IsRedirect() bool {
	return false
}

// IsClientError returns true when this get enrollments internal server error response has a 4xx status code
func (o *GetEnrollmentsInternalServerError) IsClientError() bool {
	return false
}

// IsServerError returns true when this get enrollments internal server error response has a 5xx status code
func (o *GetEnrollmentsInternalServerError) IsServerError() bool {
	return true
}

// IsCode returns true when this get enrollments internal server error response a status code equal to that given
func (o *GetEnrollmentsInternalServerError) IsCode(code int) bool {
	return code == 500
}

// Code gets the status code for the get enrollments internal server error response
func (o *GetEnrollmentsInternalServerError) Code() int {
	return 500
}

func (o *GetEnrollmentsInternalServerError) Error() string {
	return fmt.Sprintf("[GET /enrollments][%d] getEnrollmentsInternalServerError  %+v", 500, o.Payload)
}

func (o *GetEnrollmentsInternalServerError) String() string {
	return fmt.Sprintf("[GET /enrollments][%d] getEnrollmentsInternalServerError  %+v", 500, o.Payload)
}

func (o *GetEnrollmentsInternalServerError) GetPayload() *members_models.Error {
	return o.Payload
}

func (o *GetEnrollmentsInternalServerError) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(members_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
