// Code generated by go-swagger; DO NOT EDIT.

// (c) 2012-2023 by Vernon Keenan
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package favorites

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"

	"code.tnxs.net/work/lib/api/members/members_models"
)

// NewPostFavoritesParams creates a new PostFavoritesParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewPostFavoritesParams() *PostFavoritesParams {
	return &PostFavoritesParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewPostFavoritesParamsWithTimeout creates a new PostFavoritesParams object
// with the ability to set a timeout on a request.
func NewPostFavoritesParamsWithTimeout(timeout time.Duration) *PostFavoritesParams {
	return &PostFavoritesParams{
		timeout: timeout,
	}
}

// NewPostFavoritesParamsWithContext creates a new PostFavoritesParams object
// with the ability to set a context for a request.
func NewPostFavoritesParamsWithContext(ctx context.Context) *PostFavoritesParams {
	return &PostFavoritesParams{
		Context: ctx,
	}
}

// NewPostFavoritesParamsWithHTTPClient creates a new PostFavoritesParams object
// with the ability to set a custom HTTPClient for a request.
func NewPostFavoritesParamsWithHTTPClient(client *http.Client) *PostFavoritesParams {
	return &PostFavoritesParams{
		HTTPClient: client,
	}
}

/*
PostFavoritesParams contains all the parameters to send to the API endpoint

	for the post favorites operation.

	Typically these are written to a http.Request.
*/
type PostFavoritesParams struct {

	/* FavoriteRequest.

	   An array of new Favorite records
	*/
	FavoriteRequest *members_models.FavoriteRequest

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the post favorites params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *PostFavoritesParams) WithDefaults() *PostFavoritesParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the post favorites params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *PostFavoritesParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the post favorites params
func (o *PostFavoritesParams) WithTimeout(timeout time.Duration) *PostFavoritesParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the post favorites params
func (o *PostFavoritesParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the post favorites params
func (o *PostFavoritesParams) WithContext(ctx context.Context) *PostFavoritesParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the post favorites params
func (o *PostFavoritesParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the post favorites params
func (o *PostFavoritesParams) WithHTTPClient(client *http.Client) *PostFavoritesParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the post favorites params
func (o *PostFavoritesParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithFavoriteRequest adds the favoriteRequest to the post favorites params
func (o *PostFavoritesParams) WithFavoriteRequest(favoriteRequest *members_models.FavoriteRequest) *PostFavoritesParams {
	o.SetFavoriteRequest(favoriteRequest)
	return o
}

// SetFavoriteRequest adds the favoriteRequest to the post favorites params
func (o *PostFavoritesParams) SetFavoriteRequest(favoriteRequest *members_models.FavoriteRequest) {
	o.FavoriteRequest = favoriteRequest
}

// WriteToRequest writes these params to a swagger request
func (o *PostFavoritesParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error
	if o.FavoriteRequest != nil {
		if err := r.SetBodyParam(o.FavoriteRequest); err != nil {
			return err
		}
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
