// Code generated by go-swagger; DO NOT EDIT.

// (c) 2012-2023 by Vernon Keenan
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package issued_certificates

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"

	"code.tnxs.net/work/lib/api/members/members_models"
)

// NewPostIssuedCertificatesParams creates a new PostIssuedCertificatesParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewPostIssuedCertificatesParams() *PostIssuedCertificatesParams {
	return &PostIssuedCertificatesParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewPostIssuedCertificatesParamsWithTimeout creates a new PostIssuedCertificatesParams object
// with the ability to set a timeout on a request.
func NewPostIssuedCertificatesParamsWithTimeout(timeout time.Duration) *PostIssuedCertificatesParams {
	return &PostIssuedCertificatesParams{
		timeout: timeout,
	}
}

// NewPostIssuedCertificatesParamsWithContext creates a new PostIssuedCertificatesParams object
// with the ability to set a context for a request.
func NewPostIssuedCertificatesParamsWithContext(ctx context.Context) *PostIssuedCertificatesParams {
	return &PostIssuedCertificatesParams{
		Context: ctx,
	}
}

// NewPostIssuedCertificatesParamsWithHTTPClient creates a new PostIssuedCertificatesParams object
// with the ability to set a custom HTTPClient for a request.
func NewPostIssuedCertificatesParamsWithHTTPClient(client *http.Client) *PostIssuedCertificatesParams {
	return &PostIssuedCertificatesParams{
		HTTPClient: client,
	}
}

/*
PostIssuedCertificatesParams contains all the parameters to send to the API endpoint

	for the post issued certificates operation.

	Typically these are written to a http.Request.
*/
type PostIssuedCertificatesParams struct {

	/* IssuedCertificateRequest.

	   An array of new IssuedCertificate records
	*/
	IssuedCertificateRequest *members_models.IssuedCertificateRequest

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the post issued certificates params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *PostIssuedCertificatesParams) WithDefaults() *PostIssuedCertificatesParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the post issued certificates params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *PostIssuedCertificatesParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the post issued certificates params
func (o *PostIssuedCertificatesParams) WithTimeout(timeout time.Duration) *PostIssuedCertificatesParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the post issued certificates params
func (o *PostIssuedCertificatesParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the post issued certificates params
func (o *PostIssuedCertificatesParams) WithContext(ctx context.Context) *PostIssuedCertificatesParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the post issued certificates params
func (o *PostIssuedCertificatesParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the post issued certificates params
func (o *PostIssuedCertificatesParams) WithHTTPClient(client *http.Client) *PostIssuedCertificatesParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the post issued certificates params
func (o *PostIssuedCertificatesParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithIssuedCertificateRequest adds the issuedCertificateRequest to the post issued certificates params
func (o *PostIssuedCertificatesParams) WithIssuedCertificateRequest(issuedCertificateRequest *members_models.IssuedCertificateRequest) *PostIssuedCertificatesParams {
	o.SetIssuedCertificateRequest(issuedCertificateRequest)
	return o
}

// SetIssuedCertificateRequest adds the issuedCertificateRequest to the post issued certificates params
func (o *PostIssuedCertificatesParams) SetIssuedCertificateRequest(issuedCertificateRequest *members_models.IssuedCertificateRequest) {
	o.IssuedCertificateRequest = issuedCertificateRequest
}

// WriteToRequest writes these params to a swagger request
func (o *PostIssuedCertificatesParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error
	if o.IssuedCertificateRequest != nil {
		if err := r.SetBodyParam(o.IssuedCertificateRequest); err != nil {
			return err
		}
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
