// Code generated by go-swagger; DO NOT EDIT.

// (c) 2012-2023 by Vernon Keenan
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package orders

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"

	"code.tnxs.net/work/lib/api/members/members_models"
)

// NewPutOrdersParams creates a new PutOrdersParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewPutOrdersParams() *PutOrdersParams {
	return &PutOrdersParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewPutOrdersParamsWithTimeout creates a new PutOrdersParams object
// with the ability to set a timeout on a request.
func NewPutOrdersParamsWithTimeout(timeout time.Duration) *PutOrdersParams {
	return &PutOrdersParams{
		timeout: timeout,
	}
}

// NewPutOrdersParamsWithContext creates a new PutOrdersParams object
// with the ability to set a context for a request.
func NewPutOrdersParamsWithContext(ctx context.Context) *PutOrdersParams {
	return &PutOrdersParams{
		Context: ctx,
	}
}

// NewPutOrdersParamsWithHTTPClient creates a new PutOrdersParams object
// with the ability to set a custom HTTPClient for a request.
func NewPutOrdersParamsWithHTTPClient(client *http.Client) *PutOrdersParams {
	return &PutOrdersParams{
		HTTPClient: client,
	}
}

/*
PutOrdersParams contains all the parameters to send to the API endpoint

	for the put orders operation.

	Typically these are written to a http.Request.
*/
type PutOrdersParams struct {

	/* OrderRequest.

	   An array of new Order records
	*/
	OrderRequest *members_models.OrderRequest

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the put orders params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *PutOrdersParams) WithDefaults() *PutOrdersParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the put orders params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *PutOrdersParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the put orders params
func (o *PutOrdersParams) WithTimeout(timeout time.Duration) *PutOrdersParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the put orders params
func (o *PutOrdersParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the put orders params
func (o *PutOrdersParams) WithContext(ctx context.Context) *PutOrdersParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the put orders params
func (o *PutOrdersParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the put orders params
func (o *PutOrdersParams) WithHTTPClient(client *http.Client) *PutOrdersParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the put orders params
func (o *PutOrdersParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithOrderRequest adds the orderRequest to the put orders params
func (o *PutOrdersParams) WithOrderRequest(orderRequest *members_models.OrderRequest) *PutOrdersParams {
	o.SetOrderRequest(orderRequest)
	return o
}

// SetOrderRequest adds the orderRequest to the put orders params
func (o *PutOrdersParams) SetOrderRequest(orderRequest *members_models.OrderRequest) {
	o.OrderRequest = orderRequest
}

// WriteToRequest writes these params to a swagger request
func (o *PutOrdersParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error
	if o.OrderRequest != nil {
		if err := r.SetBodyParam(o.OrderRequest); err != nil {
			return err
		}
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
