// Code generated by go-swagger; DO NOT EDIT.

// (c) 2012-2023 by Vernon Keenan
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package prompts

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"

	"code.tnxs.net/work/lib/api/members/members_models"
)

// NewPostPromptCategoriesParams creates a new PostPromptCategoriesParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewPostPromptCategoriesParams() *PostPromptCategoriesParams {
	return &PostPromptCategoriesParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewPostPromptCategoriesParamsWithTimeout creates a new PostPromptCategoriesParams object
// with the ability to set a timeout on a request.
func NewPostPromptCategoriesParamsWithTimeout(timeout time.Duration) *PostPromptCategoriesParams {
	return &PostPromptCategoriesParams{
		timeout: timeout,
	}
}

// NewPostPromptCategoriesParamsWithContext creates a new PostPromptCategoriesParams object
// with the ability to set a context for a request.
func NewPostPromptCategoriesParamsWithContext(ctx context.Context) *PostPromptCategoriesParams {
	return &PostPromptCategoriesParams{
		Context: ctx,
	}
}

// NewPostPromptCategoriesParamsWithHTTPClient creates a new PostPromptCategoriesParams object
// with the ability to set a custom HTTPClient for a request.
func NewPostPromptCategoriesParamsWithHTTPClient(client *http.Client) *PostPromptCategoriesParams {
	return &PostPromptCategoriesParams{
		HTTPClient: client,
	}
}

/*
PostPromptCategoriesParams contains all the parameters to send to the API endpoint

	for the post prompt categories operation.

	Typically these are written to a http.Request.
*/
type PostPromptCategoriesParams struct {

	/* PromptCategoryRequest.

	   An array of PromptCategory objects
	*/
	PromptCategoryRequest *members_models.PromptCategoryRequest

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the post prompt categories params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *PostPromptCategoriesParams) WithDefaults() *PostPromptCategoriesParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the post prompt categories params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *PostPromptCategoriesParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the post prompt categories params
func (o *PostPromptCategoriesParams) WithTimeout(timeout time.Duration) *PostPromptCategoriesParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the post prompt categories params
func (o *PostPromptCategoriesParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the post prompt categories params
func (o *PostPromptCategoriesParams) WithContext(ctx context.Context) *PostPromptCategoriesParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the post prompt categories params
func (o *PostPromptCategoriesParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the post prompt categories params
func (o *PostPromptCategoriesParams) WithHTTPClient(client *http.Client) *PostPromptCategoriesParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the post prompt categories params
func (o *PostPromptCategoriesParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithPromptCategoryRequest adds the promptCategoryRequest to the post prompt categories params
func (o *PostPromptCategoriesParams) WithPromptCategoryRequest(promptCategoryRequest *members_models.PromptCategoryRequest) *PostPromptCategoriesParams {
	o.SetPromptCategoryRequest(promptCategoryRequest)
	return o
}

// SetPromptCategoryRequest adds the promptCategoryRequest to the post prompt categories params
func (o *PostPromptCategoriesParams) SetPromptCategoryRequest(promptCategoryRequest *members_models.PromptCategoryRequest) {
	o.PromptCategoryRequest = promptCategoryRequest
}

// WriteToRequest writes these params to a swagger request
func (o *PostPromptCategoriesParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error
	if o.PromptCategoryRequest != nil {
		if err := r.SetBodyParam(o.PromptCategoryRequest); err != nil {
			return err
		}
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
