// Code generated by go-swagger; DO NOT EDIT.

// (c) 2012-2023 by Vernon Keenan
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package research_projects

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"

	"code.tnxs.net/work/lib/api/members/members_models"
)

// NewPostResearchProjectTopicsParams creates a new PostResearchProjectTopicsParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewPostResearchProjectTopicsParams() *PostResearchProjectTopicsParams {
	return &PostResearchProjectTopicsParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewPostResearchProjectTopicsParamsWithTimeout creates a new PostResearchProjectTopicsParams object
// with the ability to set a timeout on a request.
func NewPostResearchProjectTopicsParamsWithTimeout(timeout time.Duration) *PostResearchProjectTopicsParams {
	return &PostResearchProjectTopicsParams{
		timeout: timeout,
	}
}

// NewPostResearchProjectTopicsParamsWithContext creates a new PostResearchProjectTopicsParams object
// with the ability to set a context for a request.
func NewPostResearchProjectTopicsParamsWithContext(ctx context.Context) *PostResearchProjectTopicsParams {
	return &PostResearchProjectTopicsParams{
		Context: ctx,
	}
}

// NewPostResearchProjectTopicsParamsWithHTTPClient creates a new PostResearchProjectTopicsParams object
// with the ability to set a custom HTTPClient for a request.
func NewPostResearchProjectTopicsParamsWithHTTPClient(client *http.Client) *PostResearchProjectTopicsParams {
	return &PostResearchProjectTopicsParams{
		HTTPClient: client,
	}
}

/*
PostResearchProjectTopicsParams contains all the parameters to send to the API endpoint

	for the post research project topics operation.

	Typically these are written to a http.Request.
*/
type PostResearchProjectTopicsParams struct {

	/* XAuth0UserID.

	   Auth0 User Id
	*/
	XAuth0UserID *string

	/* ResearchProjectTopicRequest.

	   An array of new ResearchProjectTopic records
	*/
	ResearchProjectTopicRequest *members_models.ResearchProjectTopicRequest

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the post research project topics params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *PostResearchProjectTopicsParams) WithDefaults() *PostResearchProjectTopicsParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the post research project topics params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *PostResearchProjectTopicsParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the post research project topics params
func (o *PostResearchProjectTopicsParams) WithTimeout(timeout time.Duration) *PostResearchProjectTopicsParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the post research project topics params
func (o *PostResearchProjectTopicsParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the post research project topics params
func (o *PostResearchProjectTopicsParams) WithContext(ctx context.Context) *PostResearchProjectTopicsParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the post research project topics params
func (o *PostResearchProjectTopicsParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the post research project topics params
func (o *PostResearchProjectTopicsParams) WithHTTPClient(client *http.Client) *PostResearchProjectTopicsParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the post research project topics params
func (o *PostResearchProjectTopicsParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithXAuth0UserID adds the xAuth0UserID to the post research project topics params
func (o *PostResearchProjectTopicsParams) WithXAuth0UserID(xAuth0UserID *string) *PostResearchProjectTopicsParams {
	o.SetXAuth0UserID(xAuth0UserID)
	return o
}

// SetXAuth0UserID adds the xAuth0UserId to the post research project topics params
func (o *PostResearchProjectTopicsParams) SetXAuth0UserID(xAuth0UserID *string) {
	o.XAuth0UserID = xAuth0UserID
}

// WithResearchProjectTopicRequest adds the researchProjectTopicRequest to the post research project topics params
func (o *PostResearchProjectTopicsParams) WithResearchProjectTopicRequest(researchProjectTopicRequest *members_models.ResearchProjectTopicRequest) *PostResearchProjectTopicsParams {
	o.SetResearchProjectTopicRequest(researchProjectTopicRequest)
	return o
}

// SetResearchProjectTopicRequest adds the researchProjectTopicRequest to the post research project topics params
func (o *PostResearchProjectTopicsParams) SetResearchProjectTopicRequest(researchProjectTopicRequest *members_models.ResearchProjectTopicRequest) {
	o.ResearchProjectTopicRequest = researchProjectTopicRequest
}

// WriteToRequest writes these params to a swagger request
func (o *PostResearchProjectTopicsParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	if o.XAuth0UserID != nil {

		// header param X-Auth0-UserId
		if err := r.SetHeaderParam("X-Auth0-UserId", *o.XAuth0UserID); err != nil {
			return err
		}
	}
	if o.ResearchProjectTopicRequest != nil {
		if err := r.SetBodyParam(o.ResearchProjectTopicRequest); err != nil {
			return err
		}
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
