// Code generated by go-swagger; DO NOT EDIT.

// (c) 2012-2023 by Vernon Keenan
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package research_projects

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"

	"code.tnxs.net/work/lib/api/members/members_models"
)

// NewPutResearchProjectServicesParams creates a new PutResearchProjectServicesParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewPutResearchProjectServicesParams() *PutResearchProjectServicesParams {
	return &PutResearchProjectServicesParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewPutResearchProjectServicesParamsWithTimeout creates a new PutResearchProjectServicesParams object
// with the ability to set a timeout on a request.
func NewPutResearchProjectServicesParamsWithTimeout(timeout time.Duration) *PutResearchProjectServicesParams {
	return &PutResearchProjectServicesParams{
		timeout: timeout,
	}
}

// NewPutResearchProjectServicesParamsWithContext creates a new PutResearchProjectServicesParams object
// with the ability to set a context for a request.
func NewPutResearchProjectServicesParamsWithContext(ctx context.Context) *PutResearchProjectServicesParams {
	return &PutResearchProjectServicesParams{
		Context: ctx,
	}
}

// NewPutResearchProjectServicesParamsWithHTTPClient creates a new PutResearchProjectServicesParams object
// with the ability to set a custom HTTPClient for a request.
func NewPutResearchProjectServicesParamsWithHTTPClient(client *http.Client) *PutResearchProjectServicesParams {
	return &PutResearchProjectServicesParams{
		HTTPClient: client,
	}
}

/*
PutResearchProjectServicesParams contains all the parameters to send to the API endpoint

	for the put research project services operation.

	Typically these are written to a http.Request.
*/
type PutResearchProjectServicesParams struct {

	/* XAuth0UserID.

	   Auth0 User Id
	*/
	XAuth0UserID *string

	/* ResearchProjectServiceRequest.

	   An array of new ResearchProjectService records
	*/
	ResearchProjectServiceRequest *members_models.ResearchProjectServiceRequest

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the put research project services params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *PutResearchProjectServicesParams) WithDefaults() *PutResearchProjectServicesParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the put research project services params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *PutResearchProjectServicesParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the put research project services params
func (o *PutResearchProjectServicesParams) WithTimeout(timeout time.Duration) *PutResearchProjectServicesParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the put research project services params
func (o *PutResearchProjectServicesParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the put research project services params
func (o *PutResearchProjectServicesParams) WithContext(ctx context.Context) *PutResearchProjectServicesParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the put research project services params
func (o *PutResearchProjectServicesParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the put research project services params
func (o *PutResearchProjectServicesParams) WithHTTPClient(client *http.Client) *PutResearchProjectServicesParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the put research project services params
func (o *PutResearchProjectServicesParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithXAuth0UserID adds the xAuth0UserID to the put research project services params
func (o *PutResearchProjectServicesParams) WithXAuth0UserID(xAuth0UserID *string) *PutResearchProjectServicesParams {
	o.SetXAuth0UserID(xAuth0UserID)
	return o
}

// SetXAuth0UserID adds the xAuth0UserId to the put research project services params
func (o *PutResearchProjectServicesParams) SetXAuth0UserID(xAuth0UserID *string) {
	o.XAuth0UserID = xAuth0UserID
}

// WithResearchProjectServiceRequest adds the researchProjectServiceRequest to the put research project services params
func (o *PutResearchProjectServicesParams) WithResearchProjectServiceRequest(researchProjectServiceRequest *members_models.ResearchProjectServiceRequest) *PutResearchProjectServicesParams {
	o.SetResearchProjectServiceRequest(researchProjectServiceRequest)
	return o
}

// SetResearchProjectServiceRequest adds the researchProjectServiceRequest to the put research project services params
func (o *PutResearchProjectServicesParams) SetResearchProjectServiceRequest(researchProjectServiceRequest *members_models.ResearchProjectServiceRequest) {
	o.ResearchProjectServiceRequest = researchProjectServiceRequest
}

// WriteToRequest writes these params to a swagger request
func (o *PutResearchProjectServicesParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	if o.XAuth0UserID != nil {

		// header param X-Auth0-UserId
		if err := r.SetHeaderParam("X-Auth0-UserId", *o.XAuth0UserID); err != nil {
			return err
		}
	}
	if o.ResearchProjectServiceRequest != nil {
		if err := r.SetBodyParam(o.ResearchProjectServiceRequest); err != nil {
			return err
		}
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
