// Code generated by go-swagger; DO NOT EDIT.

// (c) 2012-2023 by Vernon Keenan
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package tickets

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"

	"code.tnxs.net/work/lib/api/members/members_models"
)

// PostTicketsReader is a Reader for the PostTickets structure.
type PostTicketsReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *PostTicketsReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewPostTicketsOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 401:
		result := NewPostTicketsUnauthorized()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 403:
		result := NewPostTicketsForbidden()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 404:
		result := NewPostTicketsNotFound()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 422:
		result := NewPostTicketsUnprocessableEntity()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 500:
		result := NewPostTicketsInternalServerError()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		return nil, runtime.NewAPIError("response status code does not match any response statuses defined for this endpoint in the swagger spec", response, response.Code())
	}
}

// NewPostTicketsOK creates a PostTicketsOK with default headers values
func NewPostTicketsOK() *PostTicketsOK {
	return &PostTicketsOK{}
}

/*
PostTicketsOK describes a response with status code 200, with default header values.

Ticket Response Object
*/
type PostTicketsOK struct {
	Payload *members_models.TicketResponse
}

// IsSuccess returns true when this post tickets o k response has a 2xx status code
func (o *PostTicketsOK) IsSuccess() bool {
	return true
}

// IsRedirect returns true when this post tickets o k response has a 3xx status code
func (o *PostTicketsOK) IsRedirect() bool {
	return false
}

// IsClientError returns true when this post tickets o k response has a 4xx status code
func (o *PostTicketsOK) IsClientError() bool {
	return false
}

// IsServerError returns true when this post tickets o k response has a 5xx status code
func (o *PostTicketsOK) IsServerError() bool {
	return false
}

// IsCode returns true when this post tickets o k response a status code equal to that given
func (o *PostTicketsOK) IsCode(code int) bool {
	return code == 200
}

// Code gets the status code for the post tickets o k response
func (o *PostTicketsOK) Code() int {
	return 200
}

func (o *PostTicketsOK) Error() string {
	return fmt.Sprintf("[POST /tickets][%d] postTicketsOK  %+v", 200, o.Payload)
}

func (o *PostTicketsOK) String() string {
	return fmt.Sprintf("[POST /tickets][%d] postTicketsOK  %+v", 200, o.Payload)
}

func (o *PostTicketsOK) GetPayload() *members_models.TicketResponse {
	return o.Payload
}

func (o *PostTicketsOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(members_models.TicketResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPostTicketsUnauthorized creates a PostTicketsUnauthorized with default headers values
func NewPostTicketsUnauthorized() *PostTicketsUnauthorized {
	return &PostTicketsUnauthorized{}
}

/*
PostTicketsUnauthorized describes a response with status code 401, with default header values.

Access Unauthorized, invalid API-KEY was used
*/
type PostTicketsUnauthorized struct {
	Payload *members_models.Error
}

// IsSuccess returns true when this post tickets unauthorized response has a 2xx status code
func (o *PostTicketsUnauthorized) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this post tickets unauthorized response has a 3xx status code
func (o *PostTicketsUnauthorized) IsRedirect() bool {
	return false
}

// IsClientError returns true when this post tickets unauthorized response has a 4xx status code
func (o *PostTicketsUnauthorized) IsClientError() bool {
	return true
}

// IsServerError returns true when this post tickets unauthorized response has a 5xx status code
func (o *PostTicketsUnauthorized) IsServerError() bool {
	return false
}

// IsCode returns true when this post tickets unauthorized response a status code equal to that given
func (o *PostTicketsUnauthorized) IsCode(code int) bool {
	return code == 401
}

// Code gets the status code for the post tickets unauthorized response
func (o *PostTicketsUnauthorized) Code() int {
	return 401
}

func (o *PostTicketsUnauthorized) Error() string {
	return fmt.Sprintf("[POST /tickets][%d] postTicketsUnauthorized  %+v", 401, o.Payload)
}

func (o *PostTicketsUnauthorized) String() string {
	return fmt.Sprintf("[POST /tickets][%d] postTicketsUnauthorized  %+v", 401, o.Payload)
}

func (o *PostTicketsUnauthorized) GetPayload() *members_models.Error {
	return o.Payload
}

func (o *PostTicketsUnauthorized) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(members_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPostTicketsForbidden creates a PostTicketsForbidden with default headers values
func NewPostTicketsForbidden() *PostTicketsForbidden {
	return &PostTicketsForbidden{}
}

/*
PostTicketsForbidden describes a response with status code 403, with default header values.

Access forbidden, account lacks access
*/
type PostTicketsForbidden struct {
	AccessControlAllowOrigin string

	Payload *members_models.Error
}

// IsSuccess returns true when this post tickets forbidden response has a 2xx status code
func (o *PostTicketsForbidden) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this post tickets forbidden response has a 3xx status code
func (o *PostTicketsForbidden) IsRedirect() bool {
	return false
}

// IsClientError returns true when this post tickets forbidden response has a 4xx status code
func (o *PostTicketsForbidden) IsClientError() bool {
	return true
}

// IsServerError returns true when this post tickets forbidden response has a 5xx status code
func (o *PostTicketsForbidden) IsServerError() bool {
	return false
}

// IsCode returns true when this post tickets forbidden response a status code equal to that given
func (o *PostTicketsForbidden) IsCode(code int) bool {
	return code == 403
}

// Code gets the status code for the post tickets forbidden response
func (o *PostTicketsForbidden) Code() int {
	return 403
}

func (o *PostTicketsForbidden) Error() string {
	return fmt.Sprintf("[POST /tickets][%d] postTicketsForbidden  %+v", 403, o.Payload)
}

func (o *PostTicketsForbidden) String() string {
	return fmt.Sprintf("[POST /tickets][%d] postTicketsForbidden  %+v", 403, o.Payload)
}

func (o *PostTicketsForbidden) GetPayload() *members_models.Error {
	return o.Payload
}

func (o *PostTicketsForbidden) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header Access-Control-Allow-Origin
	hdrAccessControlAllowOrigin := response.GetHeader("Access-Control-Allow-Origin")

	if hdrAccessControlAllowOrigin != "" {
		o.AccessControlAllowOrigin = hdrAccessControlAllowOrigin
	}

	o.Payload = new(members_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPostTicketsNotFound creates a PostTicketsNotFound with default headers values
func NewPostTicketsNotFound() *PostTicketsNotFound {
	return &PostTicketsNotFound{}
}

/*
PostTicketsNotFound describes a response with status code 404, with default header values.

Resource was not found
*/
type PostTicketsNotFound struct {
	Payload *members_models.Error
}

// IsSuccess returns true when this post tickets not found response has a 2xx status code
func (o *PostTicketsNotFound) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this post tickets not found response has a 3xx status code
func (o *PostTicketsNotFound) IsRedirect() bool {
	return false
}

// IsClientError returns true when this post tickets not found response has a 4xx status code
func (o *PostTicketsNotFound) IsClientError() bool {
	return true
}

// IsServerError returns true when this post tickets not found response has a 5xx status code
func (o *PostTicketsNotFound) IsServerError() bool {
	return false
}

// IsCode returns true when this post tickets not found response a status code equal to that given
func (o *PostTicketsNotFound) IsCode(code int) bool {
	return code == 404
}

// Code gets the status code for the post tickets not found response
func (o *PostTicketsNotFound) Code() int {
	return 404
}

func (o *PostTicketsNotFound) Error() string {
	return fmt.Sprintf("[POST /tickets][%d] postTicketsNotFound  %+v", 404, o.Payload)
}

func (o *PostTicketsNotFound) String() string {
	return fmt.Sprintf("[POST /tickets][%d] postTicketsNotFound  %+v", 404, o.Payload)
}

func (o *PostTicketsNotFound) GetPayload() *members_models.Error {
	return o.Payload
}

func (o *PostTicketsNotFound) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(members_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPostTicketsUnprocessableEntity creates a PostTicketsUnprocessableEntity with default headers values
func NewPostTicketsUnprocessableEntity() *PostTicketsUnprocessableEntity {
	return &PostTicketsUnprocessableEntity{}
}

/*
PostTicketsUnprocessableEntity describes a response with status code 422, with default header values.

Unprocessable Entity, likely a bad parameter
*/
type PostTicketsUnprocessableEntity struct {
	Payload *members_models.Error
}

// IsSuccess returns true when this post tickets unprocessable entity response has a 2xx status code
func (o *PostTicketsUnprocessableEntity) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this post tickets unprocessable entity response has a 3xx status code
func (o *PostTicketsUnprocessableEntity) IsRedirect() bool {
	return false
}

// IsClientError returns true when this post tickets unprocessable entity response has a 4xx status code
func (o *PostTicketsUnprocessableEntity) IsClientError() bool {
	return true
}

// IsServerError returns true when this post tickets unprocessable entity response has a 5xx status code
func (o *PostTicketsUnprocessableEntity) IsServerError() bool {
	return false
}

// IsCode returns true when this post tickets unprocessable entity response a status code equal to that given
func (o *PostTicketsUnprocessableEntity) IsCode(code int) bool {
	return code == 422
}

// Code gets the status code for the post tickets unprocessable entity response
func (o *PostTicketsUnprocessableEntity) Code() int {
	return 422
}

func (o *PostTicketsUnprocessableEntity) Error() string {
	return fmt.Sprintf("[POST /tickets][%d] postTicketsUnprocessableEntity  %+v", 422, o.Payload)
}

func (o *PostTicketsUnprocessableEntity) String() string {
	return fmt.Sprintf("[POST /tickets][%d] postTicketsUnprocessableEntity  %+v", 422, o.Payload)
}

func (o *PostTicketsUnprocessableEntity) GetPayload() *members_models.Error {
	return o.Payload
}

func (o *PostTicketsUnprocessableEntity) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(members_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPostTicketsInternalServerError creates a PostTicketsInternalServerError with default headers values
func NewPostTicketsInternalServerError() *PostTicketsInternalServerError {
	return &PostTicketsInternalServerError{}
}

/*
PostTicketsInternalServerError describes a response with status code 500, with default header values.

Server Internal Error
*/
type PostTicketsInternalServerError struct {
	Payload *members_models.Error
}

// IsSuccess returns true when this post tickets internal server error response has a 2xx status code
func (o *PostTicketsInternalServerError) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this post tickets internal server error response has a 3xx status code
func (o *PostTicketsInternalServerError) IsRedirect() bool {
	return false
}

// IsClientError returns true when this post tickets internal server error response has a 4xx status code
func (o *PostTicketsInternalServerError) IsClientError() bool {
	return false
}

// IsServerError returns true when this post tickets internal server error response has a 5xx status code
func (o *PostTicketsInternalServerError) IsServerError() bool {
	return true
}

// IsCode returns true when this post tickets internal server error response a status code equal to that given
func (o *PostTicketsInternalServerError) IsCode(code int) bool {
	return code == 500
}

// Code gets the status code for the post tickets internal server error response
func (o *PostTicketsInternalServerError) Code() int {
	return 500
}

func (o *PostTicketsInternalServerError) Error() string {
	return fmt.Sprintf("[POST /tickets][%d] postTicketsInternalServerError  %+v", 500, o.Payload)
}

func (o *PostTicketsInternalServerError) String() string {
	return fmt.Sprintf("[POST /tickets][%d] postTicketsInternalServerError  %+v", 500, o.Payload)
}

func (o *PostTicketsInternalServerError) GetPayload() *members_models.Error {
	return o.Payload
}

func (o *PostTicketsInternalServerError) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(members_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
