// Code generated by go-swagger; DO NOT EDIT.

// (c) 2012-2023 by Vernon Keenan
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package tickets

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"

	"code.tnxs.net/work/lib/api/members/members_models"
)

// NewPutTicketsParams creates a new PutTicketsParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewPutTicketsParams() *PutTicketsParams {
	return &PutTicketsParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewPutTicketsParamsWithTimeout creates a new PutTicketsParams object
// with the ability to set a timeout on a request.
func NewPutTicketsParamsWithTimeout(timeout time.Duration) *PutTicketsParams {
	return &PutTicketsParams{
		timeout: timeout,
	}
}

// NewPutTicketsParamsWithContext creates a new PutTicketsParams object
// with the ability to set a context for a request.
func NewPutTicketsParamsWithContext(ctx context.Context) *PutTicketsParams {
	return &PutTicketsParams{
		Context: ctx,
	}
}

// NewPutTicketsParamsWithHTTPClient creates a new PutTicketsParams object
// with the ability to set a custom HTTPClient for a request.
func NewPutTicketsParamsWithHTTPClient(client *http.Client) *PutTicketsParams {
	return &PutTicketsParams{
		HTTPClient: client,
	}
}

/*
PutTicketsParams contains all the parameters to send to the API endpoint

	for the put tickets operation.

	Typically these are written to a http.Request.
*/
type PutTicketsParams struct {

	/* TicketRequest.

	   An array of new Ticket records
	*/
	TicketRequest *members_models.TicketRequest

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the put tickets params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *PutTicketsParams) WithDefaults() *PutTicketsParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the put tickets params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *PutTicketsParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the put tickets params
func (o *PutTicketsParams) WithTimeout(timeout time.Duration) *PutTicketsParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the put tickets params
func (o *PutTicketsParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the put tickets params
func (o *PutTicketsParams) WithContext(ctx context.Context) *PutTicketsParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the put tickets params
func (o *PutTicketsParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the put tickets params
func (o *PutTicketsParams) WithHTTPClient(client *http.Client) *PutTicketsParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the put tickets params
func (o *PutTicketsParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithTicketRequest adds the ticketRequest to the put tickets params
func (o *PutTicketsParams) WithTicketRequest(ticketRequest *members_models.TicketRequest) *PutTicketsParams {
	o.SetTicketRequest(ticketRequest)
	return o
}

// SetTicketRequest adds the ticketRequest to the put tickets params
func (o *PutTicketsParams) SetTicketRequest(ticketRequest *members_models.TicketRequest) {
	o.TicketRequest = ticketRequest
}

// WriteToRequest writes these params to a swagger request
func (o *PutTicketsParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error
	if o.TicketRequest != nil {
		if err := r.SetBodyParam(o.TicketRequest); err != nil {
			return err
		}
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
