// Code generated by go-swagger; DO NOT EDIT.

// (c) 2012-2023 by Vernon Keenan
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package transactions

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"

	"code.tnxs.net/work/lib/api/members/members_models"
)

// NewPostTransactionsParams creates a new PostTransactionsParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewPostTransactionsParams() *PostTransactionsParams {
	return &PostTransactionsParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewPostTransactionsParamsWithTimeout creates a new PostTransactionsParams object
// with the ability to set a timeout on a request.
func NewPostTransactionsParamsWithTimeout(timeout time.Duration) *PostTransactionsParams {
	return &PostTransactionsParams{
		timeout: timeout,
	}
}

// NewPostTransactionsParamsWithContext creates a new PostTransactionsParams object
// with the ability to set a context for a request.
func NewPostTransactionsParamsWithContext(ctx context.Context) *PostTransactionsParams {
	return &PostTransactionsParams{
		Context: ctx,
	}
}

// NewPostTransactionsParamsWithHTTPClient creates a new PostTransactionsParams object
// with the ability to set a custom HTTPClient for a request.
func NewPostTransactionsParamsWithHTTPClient(client *http.Client) *PostTransactionsParams {
	return &PostTransactionsParams{
		HTTPClient: client,
	}
}

/*
PostTransactionsParams contains all the parameters to send to the API endpoint

	for the post transactions operation.

	Typically these are written to a http.Request.
*/
type PostTransactionsParams struct {

	/* TransactionRequest.

	   An array of new Transaction records
	*/
	TransactionRequest *members_models.TransactionRequest

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the post transactions params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *PostTransactionsParams) WithDefaults() *PostTransactionsParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the post transactions params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *PostTransactionsParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the post transactions params
func (o *PostTransactionsParams) WithTimeout(timeout time.Duration) *PostTransactionsParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the post transactions params
func (o *PostTransactionsParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the post transactions params
func (o *PostTransactionsParams) WithContext(ctx context.Context) *PostTransactionsParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the post transactions params
func (o *PostTransactionsParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the post transactions params
func (o *PostTransactionsParams) WithHTTPClient(client *http.Client) *PostTransactionsParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the post transactions params
func (o *PostTransactionsParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithTransactionRequest adds the transactionRequest to the post transactions params
func (o *PostTransactionsParams) WithTransactionRequest(transactionRequest *members_models.TransactionRequest) *PostTransactionsParams {
	o.SetTransactionRequest(transactionRequest)
	return o
}

// SetTransactionRequest adds the transactionRequest to the post transactions params
func (o *PostTransactionsParams) SetTransactionRequest(transactionRequest *members_models.TransactionRequest) {
	o.TransactionRequest = transactionRequest
}

// WriteToRequest writes these params to a swagger request
func (o *PostTransactionsParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error
	if o.TransactionRequest != nil {
		if err := r.SetBodyParam(o.TransactionRequest); err != nil {
			return err
		}
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
