// Code generated by go-swagger; DO NOT EDIT.

// (c) 2012-2023 by Vernon Keenan
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package users

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
)

// NewGetUsersParams creates a new GetUsersParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewGetUsersParams() *GetUsersParams {
	return &GetUsersParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewGetUsersParamsWithTimeout creates a new GetUsersParams object
// with the ability to set a timeout on a request.
func NewGetUsersParamsWithTimeout(timeout time.Duration) *GetUsersParams {
	return &GetUsersParams{
		timeout: timeout,
	}
}

// NewGetUsersParamsWithContext creates a new GetUsersParams object
// with the ability to set a context for a request.
func NewGetUsersParamsWithContext(ctx context.Context) *GetUsersParams {
	return &GetUsersParams{
		Context: ctx,
	}
}

// NewGetUsersParamsWithHTTPClient creates a new GetUsersParams object
// with the ability to set a custom HTTPClient for a request.
func NewGetUsersParamsWithHTTPClient(client *http.Client) *GetUsersParams {
	return &GetUsersParams{
		HTTPClient: client,
	}
}

/*
GetUsersParams contains all the parameters to send to the API endpoint

	for the get users operation.

	Typically these are written to a http.Request.
*/
type GetUsersParams struct {

	/* Auth0UserID.

	   External Auth0 User ID
	*/
	Auth0UserID *string

	/* ContactID.

	   Internal Contact ID (links to Account)
	*/
	ContactID *string

	/* Email.

	   Email address
	*/
	Email *string

	/* Limit.

	   How many objects to return at one time

	   Format: int64
	*/
	Limit *int64

	/* Offset.

	   How many objects to skip?

	   Format: int64
	*/
	Offset *int64

	/* UserID.

	   Internal User ID
	*/
	UserID *string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the get users params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *GetUsersParams) WithDefaults() *GetUsersParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the get users params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *GetUsersParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the get users params
func (o *GetUsersParams) WithTimeout(timeout time.Duration) *GetUsersParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the get users params
func (o *GetUsersParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the get users params
func (o *GetUsersParams) WithContext(ctx context.Context) *GetUsersParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the get users params
func (o *GetUsersParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the get users params
func (o *GetUsersParams) WithHTTPClient(client *http.Client) *GetUsersParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the get users params
func (o *GetUsersParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithAuth0UserID adds the auth0UserID to the get users params
func (o *GetUsersParams) WithAuth0UserID(auth0UserID *string) *GetUsersParams {
	o.SetAuth0UserID(auth0UserID)
	return o
}

// SetAuth0UserID adds the auth0UserId to the get users params
func (o *GetUsersParams) SetAuth0UserID(auth0UserID *string) {
	o.Auth0UserID = auth0UserID
}

// WithContactID adds the contactID to the get users params
func (o *GetUsersParams) WithContactID(contactID *string) *GetUsersParams {
	o.SetContactID(contactID)
	return o
}

// SetContactID adds the contactId to the get users params
func (o *GetUsersParams) SetContactID(contactID *string) {
	o.ContactID = contactID
}

// WithEmail adds the email to the get users params
func (o *GetUsersParams) WithEmail(email *string) *GetUsersParams {
	o.SetEmail(email)
	return o
}

// SetEmail adds the email to the get users params
func (o *GetUsersParams) SetEmail(email *string) {
	o.Email = email
}

// WithLimit adds the limit to the get users params
func (o *GetUsersParams) WithLimit(limit *int64) *GetUsersParams {
	o.SetLimit(limit)
	return o
}

// SetLimit adds the limit to the get users params
func (o *GetUsersParams) SetLimit(limit *int64) {
	o.Limit = limit
}

// WithOffset adds the offset to the get users params
func (o *GetUsersParams) WithOffset(offset *int64) *GetUsersParams {
	o.SetOffset(offset)
	return o
}

// SetOffset adds the offset to the get users params
func (o *GetUsersParams) SetOffset(offset *int64) {
	o.Offset = offset
}

// WithUserID adds the userID to the get users params
func (o *GetUsersParams) WithUserID(userID *string) *GetUsersParams {
	o.SetUserID(userID)
	return o
}

// SetUserID adds the userId to the get users params
func (o *GetUsersParams) SetUserID(userID *string) {
	o.UserID = userID
}

// WriteToRequest writes these params to a swagger request
func (o *GetUsersParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	if o.Auth0UserID != nil {

		// query param auth0UserId
		var qrAuth0UserID string

		if o.Auth0UserID != nil {
			qrAuth0UserID = *o.Auth0UserID
		}
		qAuth0UserID := qrAuth0UserID
		if qAuth0UserID != "" {

			if err := r.SetQueryParam("auth0UserId", qAuth0UserID); err != nil {
				return err
			}
		}
	}

	if o.ContactID != nil {

		// query param contactId
		var qrContactID string

		if o.ContactID != nil {
			qrContactID = *o.ContactID
		}
		qContactID := qrContactID
		if qContactID != "" {

			if err := r.SetQueryParam("contactId", qContactID); err != nil {
				return err
			}
		}
	}

	if o.Email != nil {

		// query param email
		var qrEmail string

		if o.Email != nil {
			qrEmail = *o.Email
		}
		qEmail := qrEmail
		if qEmail != "" {

			if err := r.SetQueryParam("email", qEmail); err != nil {
				return err
			}
		}
	}

	if o.Limit != nil {

		// query param limit
		var qrLimit int64

		if o.Limit != nil {
			qrLimit = *o.Limit
		}
		qLimit := swag.FormatInt64(qrLimit)
		if qLimit != "" {

			if err := r.SetQueryParam("limit", qLimit); err != nil {
				return err
			}
		}
	}

	if o.Offset != nil {

		// query param offset
		var qrOffset int64

		if o.Offset != nil {
			qrOffset = *o.Offset
		}
		qOffset := swag.FormatInt64(qrOffset)
		if qOffset != "" {

			if err := r.SetQueryParam("offset", qOffset); err != nil {
				return err
			}
		}
	}

	if o.UserID != nil {

		// query param userId
		var qrUserID string

		if o.UserID != nil {
			qrUserID = *o.UserID
		}
		qUserID := qrUserID
		if qUserID != "" {

			if err := r.SetQueryParam("userId", qUserID); err != nil {
				return err
			}
		}
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
