// Code generated by go-swagger; DO NOT EDIT.

// (c) 2012-2023 by Vernon Keenan
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package webhooks

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"

	"code.tnxs.net/work/lib/api/members/members_models"
)

// NewPostWebhooksClerkParams creates a new PostWebhooksClerkParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewPostWebhooksClerkParams() *PostWebhooksClerkParams {
	return &PostWebhooksClerkParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewPostWebhooksClerkParamsWithTimeout creates a new PostWebhooksClerkParams object
// with the ability to set a timeout on a request.
func NewPostWebhooksClerkParamsWithTimeout(timeout time.Duration) *PostWebhooksClerkParams {
	return &PostWebhooksClerkParams{
		timeout: timeout,
	}
}

// NewPostWebhooksClerkParamsWithContext creates a new PostWebhooksClerkParams object
// with the ability to set a context for a request.
func NewPostWebhooksClerkParamsWithContext(ctx context.Context) *PostWebhooksClerkParams {
	return &PostWebhooksClerkParams{
		Context: ctx,
	}
}

// NewPostWebhooksClerkParamsWithHTTPClient creates a new PostWebhooksClerkParams object
// with the ability to set a custom HTTPClient for a request.
func NewPostWebhooksClerkParamsWithHTTPClient(client *http.Client) *PostWebhooksClerkParams {
	return &PostWebhooksClerkParams{
		HTTPClient: client,
	}
}

/*
PostWebhooksClerkParams contains all the parameters to send to the API endpoint

	for the post webhooks clerk operation.

	Typically these are written to a http.Request.
*/
type PostWebhooksClerkParams struct {

	/* WebhookclerkRequest.

	   An array of new WebhookClerk records
	*/
	WebhookclerkRequest *members_models.WebhookClerkRequest

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the post webhooks clerk params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *PostWebhooksClerkParams) WithDefaults() *PostWebhooksClerkParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the post webhooks clerk params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *PostWebhooksClerkParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the post webhooks clerk params
func (o *PostWebhooksClerkParams) WithTimeout(timeout time.Duration) *PostWebhooksClerkParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the post webhooks clerk params
func (o *PostWebhooksClerkParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the post webhooks clerk params
func (o *PostWebhooksClerkParams) WithContext(ctx context.Context) *PostWebhooksClerkParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the post webhooks clerk params
func (o *PostWebhooksClerkParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the post webhooks clerk params
func (o *PostWebhooksClerkParams) WithHTTPClient(client *http.Client) *PostWebhooksClerkParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the post webhooks clerk params
func (o *PostWebhooksClerkParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithWebhookclerkRequest adds the webhookclerkRequest to the post webhooks clerk params
func (o *PostWebhooksClerkParams) WithWebhookclerkRequest(webhookclerkRequest *members_models.WebhookClerkRequest) *PostWebhooksClerkParams {
	o.SetWebhookclerkRequest(webhookclerkRequest)
	return o
}

// SetWebhookclerkRequest adds the webhookclerkRequest to the post webhooks clerk params
func (o *PostWebhooksClerkParams) SetWebhookclerkRequest(webhookclerkRequest *members_models.WebhookClerkRequest) {
	o.WebhookclerkRequest = webhookclerkRequest
}

// WriteToRequest writes these params to a swagger request
func (o *PostWebhooksClerkParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error
	if o.WebhookclerkRequest != nil {
		if err := r.SetBodyParam(o.WebhookclerkRequest); err != nil {
			return err
		}
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
