// Code generated by go-swagger; DO NOT EDIT.

// (c) 2012-2023 by Vernon Keenan
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package accounts

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"

	"code.tnxs.net/work/lib/api/sfgate/sfgate_models"
)

// GetAccountsReader is a Reader for the GetAccounts structure.
type GetAccountsReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *GetAccountsReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewGetAccountsOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 401:
		result := NewGetAccountsUnauthorized()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 403:
		result := NewGetAccountsForbidden()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 404:
		result := NewGetAccountsNotFound()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 422:
		result := NewGetAccountsUnprocessableEntity()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 500:
		result := NewGetAccountsInternalServerError()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		return nil, runtime.NewAPIError("response status code does not match any response statuses defined for this endpoint in the swagger spec", response, response.Code())
	}
}

// NewGetAccountsOK creates a GetAccountsOK with default headers values
func NewGetAccountsOK() *GetAccountsOK {
	return &GetAccountsOK{}
}

/*
GetAccountsOK describes a response with status code 200, with default header values.

Response with Account objects
*/
type GetAccountsOK struct {
	Payload *sfgate_models.AccountResponse
}

// IsSuccess returns true when this get accounts o k response has a 2xx status code
func (o *GetAccountsOK) IsSuccess() bool {
	return true
}

// IsRedirect returns true when this get accounts o k response has a 3xx status code
func (o *GetAccountsOK) IsRedirect() bool {
	return false
}

// IsClientError returns true when this get accounts o k response has a 4xx status code
func (o *GetAccountsOK) IsClientError() bool {
	return false
}

// IsServerError returns true when this get accounts o k response has a 5xx status code
func (o *GetAccountsOK) IsServerError() bool {
	return false
}

// IsCode returns true when this get accounts o k response a status code equal to that given
func (o *GetAccountsOK) IsCode(code int) bool {
	return code == 200
}

// Code gets the status code for the get accounts o k response
func (o *GetAccountsOK) Code() int {
	return 200
}

func (o *GetAccountsOK) Error() string {
	return fmt.Sprintf("[GET /accounts][%d] getAccountsOK  %+v", 200, o.Payload)
}

func (o *GetAccountsOK) String() string {
	return fmt.Sprintf("[GET /accounts][%d] getAccountsOK  %+v", 200, o.Payload)
}

func (o *GetAccountsOK) GetPayload() *sfgate_models.AccountResponse {
	return o.Payload
}

func (o *GetAccountsOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(sfgate_models.AccountResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetAccountsUnauthorized creates a GetAccountsUnauthorized with default headers values
func NewGetAccountsUnauthorized() *GetAccountsUnauthorized {
	return &GetAccountsUnauthorized{}
}

/*
GetAccountsUnauthorized describes a response with status code 401, with default header values.

Access unauthorized, invalid API-KEY was used
*/
type GetAccountsUnauthorized struct {
	Payload *sfgate_models.Error
}

// IsSuccess returns true when this get accounts unauthorized response has a 2xx status code
func (o *GetAccountsUnauthorized) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this get accounts unauthorized response has a 3xx status code
func (o *GetAccountsUnauthorized) IsRedirect() bool {
	return false
}

// IsClientError returns true when this get accounts unauthorized response has a 4xx status code
func (o *GetAccountsUnauthorized) IsClientError() bool {
	return true
}

// IsServerError returns true when this get accounts unauthorized response has a 5xx status code
func (o *GetAccountsUnauthorized) IsServerError() bool {
	return false
}

// IsCode returns true when this get accounts unauthorized response a status code equal to that given
func (o *GetAccountsUnauthorized) IsCode(code int) bool {
	return code == 401
}

// Code gets the status code for the get accounts unauthorized response
func (o *GetAccountsUnauthorized) Code() int {
	return 401
}

func (o *GetAccountsUnauthorized) Error() string {
	return fmt.Sprintf("[GET /accounts][%d] getAccountsUnauthorized  %+v", 401, o.Payload)
}

func (o *GetAccountsUnauthorized) String() string {
	return fmt.Sprintf("[GET /accounts][%d] getAccountsUnauthorized  %+v", 401, o.Payload)
}

func (o *GetAccountsUnauthorized) GetPayload() *sfgate_models.Error {
	return o.Payload
}

func (o *GetAccountsUnauthorized) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(sfgate_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetAccountsForbidden creates a GetAccountsForbidden with default headers values
func NewGetAccountsForbidden() *GetAccountsForbidden {
	return &GetAccountsForbidden{}
}

/*
GetAccountsForbidden describes a response with status code 403, with default header values.

Access forbidden, account lacks access
*/
type GetAccountsForbidden struct {
	Payload *sfgate_models.Error
}

// IsSuccess returns true when this get accounts forbidden response has a 2xx status code
func (o *GetAccountsForbidden) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this get accounts forbidden response has a 3xx status code
func (o *GetAccountsForbidden) IsRedirect() bool {
	return false
}

// IsClientError returns true when this get accounts forbidden response has a 4xx status code
func (o *GetAccountsForbidden) IsClientError() bool {
	return true
}

// IsServerError returns true when this get accounts forbidden response has a 5xx status code
func (o *GetAccountsForbidden) IsServerError() bool {
	return false
}

// IsCode returns true when this get accounts forbidden response a status code equal to that given
func (o *GetAccountsForbidden) IsCode(code int) bool {
	return code == 403
}

// Code gets the status code for the get accounts forbidden response
func (o *GetAccountsForbidden) Code() int {
	return 403
}

func (o *GetAccountsForbidden) Error() string {
	return fmt.Sprintf("[GET /accounts][%d] getAccountsForbidden  %+v", 403, o.Payload)
}

func (o *GetAccountsForbidden) String() string {
	return fmt.Sprintf("[GET /accounts][%d] getAccountsForbidden  %+v", 403, o.Payload)
}

func (o *GetAccountsForbidden) GetPayload() *sfgate_models.Error {
	return o.Payload
}

func (o *GetAccountsForbidden) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(sfgate_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetAccountsNotFound creates a GetAccountsNotFound with default headers values
func NewGetAccountsNotFound() *GetAccountsNotFound {
	return &GetAccountsNotFound{}
}

/*
GetAccountsNotFound describes a response with status code 404, with default header values.

Resource was not found
*/
type GetAccountsNotFound struct {
	Payload *sfgate_models.Error
}

// IsSuccess returns true when this get accounts not found response has a 2xx status code
func (o *GetAccountsNotFound) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this get accounts not found response has a 3xx status code
func (o *GetAccountsNotFound) IsRedirect() bool {
	return false
}

// IsClientError returns true when this get accounts not found response has a 4xx status code
func (o *GetAccountsNotFound) IsClientError() bool {
	return true
}

// IsServerError returns true when this get accounts not found response has a 5xx status code
func (o *GetAccountsNotFound) IsServerError() bool {
	return false
}

// IsCode returns true when this get accounts not found response a status code equal to that given
func (o *GetAccountsNotFound) IsCode(code int) bool {
	return code == 404
}

// Code gets the status code for the get accounts not found response
func (o *GetAccountsNotFound) Code() int {
	return 404
}

func (o *GetAccountsNotFound) Error() string {
	return fmt.Sprintf("[GET /accounts][%d] getAccountsNotFound  %+v", 404, o.Payload)
}

func (o *GetAccountsNotFound) String() string {
	return fmt.Sprintf("[GET /accounts][%d] getAccountsNotFound  %+v", 404, o.Payload)
}

func (o *GetAccountsNotFound) GetPayload() *sfgate_models.Error {
	return o.Payload
}

func (o *GetAccountsNotFound) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(sfgate_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetAccountsUnprocessableEntity creates a GetAccountsUnprocessableEntity with default headers values
func NewGetAccountsUnprocessableEntity() *GetAccountsUnprocessableEntity {
	return &GetAccountsUnprocessableEntity{}
}

/*
GetAccountsUnprocessableEntity describes a response with status code 422, with default header values.

Unprocessable Entity, likely a bad parameter
*/
type GetAccountsUnprocessableEntity struct {
	Payload *sfgate_models.Error
}

// IsSuccess returns true when this get accounts unprocessable entity response has a 2xx status code
func (o *GetAccountsUnprocessableEntity) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this get accounts unprocessable entity response has a 3xx status code
func (o *GetAccountsUnprocessableEntity) IsRedirect() bool {
	return false
}

// IsClientError returns true when this get accounts unprocessable entity response has a 4xx status code
func (o *GetAccountsUnprocessableEntity) IsClientError() bool {
	return true
}

// IsServerError returns true when this get accounts unprocessable entity response has a 5xx status code
func (o *GetAccountsUnprocessableEntity) IsServerError() bool {
	return false
}

// IsCode returns true when this get accounts unprocessable entity response a status code equal to that given
func (o *GetAccountsUnprocessableEntity) IsCode(code int) bool {
	return code == 422
}

// Code gets the status code for the get accounts unprocessable entity response
func (o *GetAccountsUnprocessableEntity) Code() int {
	return 422
}

func (o *GetAccountsUnprocessableEntity) Error() string {
	return fmt.Sprintf("[GET /accounts][%d] getAccountsUnprocessableEntity  %+v", 422, o.Payload)
}

func (o *GetAccountsUnprocessableEntity) String() string {
	return fmt.Sprintf("[GET /accounts][%d] getAccountsUnprocessableEntity  %+v", 422, o.Payload)
}

func (o *GetAccountsUnprocessableEntity) GetPayload() *sfgate_models.Error {
	return o.Payload
}

func (o *GetAccountsUnprocessableEntity) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(sfgate_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetAccountsInternalServerError creates a GetAccountsInternalServerError with default headers values
func NewGetAccountsInternalServerError() *GetAccountsInternalServerError {
	return &GetAccountsInternalServerError{}
}

/*
GetAccountsInternalServerError describes a response with status code 500, with default header values.

Server Internal Error
*/
type GetAccountsInternalServerError struct {
	Payload *sfgate_models.Error
}

// IsSuccess returns true when this get accounts internal server error response has a 2xx status code
func (o *GetAccountsInternalServerError) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this get accounts internal server error response has a 3xx status code
func (o *GetAccountsInternalServerError) IsRedirect() bool {
	return false
}

// IsClientError returns true when this get accounts internal server error response has a 4xx status code
func (o *GetAccountsInternalServerError) IsClientError() bool {
	return false
}

// IsServerError returns true when this get accounts internal server error response has a 5xx status code
func (o *GetAccountsInternalServerError) IsServerError() bool {
	return true
}

// IsCode returns true when this get accounts internal server error response a status code equal to that given
func (o *GetAccountsInternalServerError) IsCode(code int) bool {
	return code == 500
}

// Code gets the status code for the get accounts internal server error response
func (o *GetAccountsInternalServerError) Code() int {
	return 500
}

func (o *GetAccountsInternalServerError) Error() string {
	return fmt.Sprintf("[GET /accounts][%d] getAccountsInternalServerError  %+v", 500, o.Payload)
}

func (o *GetAccountsInternalServerError) String() string {
	return fmt.Sprintf("[GET /accounts][%d] getAccountsInternalServerError  %+v", 500, o.Payload)
}

func (o *GetAccountsInternalServerError) GetPayload() *sfgate_models.Error {
	return o.Payload
}

func (o *GetAccountsInternalServerError) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(sfgate_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
