// Code generated by go-swagger; DO NOT EDIT.

// (c) 2012-2023 by Vernon Keenan
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package contacts

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"

	"code.tnxs.net/work/lib/api/sfgate/sfgate_models"
)

// PutContactsReader is a Reader for the PutContacts structure.
type PutContactsReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *PutContactsReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewPutContactsOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 401:
		result := NewPutContactsUnauthorized()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 403:
		result := NewPutContactsForbidden()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 404:
		result := NewPutContactsNotFound()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 422:
		result := NewPutContactsUnprocessableEntity()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 500:
		result := NewPutContactsInternalServerError()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		return nil, runtime.NewAPIError("response status code does not match any response statuses defined for this endpoint in the swagger spec", response, response.Code())
	}
}

// NewPutContactsOK creates a PutContactsOK with default headers values
func NewPutContactsOK() *PutContactsOK {
	return &PutContactsOK{}
}

/*
PutContactsOK describes a response with status code 200, with default header values.

Response with Contact objects
*/
type PutContactsOK struct {
	Payload *sfgate_models.ContactResponse
}

// IsSuccess returns true when this put contacts o k response has a 2xx status code
func (o *PutContactsOK) IsSuccess() bool {
	return true
}

// IsRedirect returns true when this put contacts o k response has a 3xx status code
func (o *PutContactsOK) IsRedirect() bool {
	return false
}

// IsClientError returns true when this put contacts o k response has a 4xx status code
func (o *PutContactsOK) IsClientError() bool {
	return false
}

// IsServerError returns true when this put contacts o k response has a 5xx status code
func (o *PutContactsOK) IsServerError() bool {
	return false
}

// IsCode returns true when this put contacts o k response a status code equal to that given
func (o *PutContactsOK) IsCode(code int) bool {
	return code == 200
}

// Code gets the status code for the put contacts o k response
func (o *PutContactsOK) Code() int {
	return 200
}

func (o *PutContactsOK) Error() string {
	return fmt.Sprintf("[PUT /contacts][%d] putContactsOK  %+v", 200, o.Payload)
}

func (o *PutContactsOK) String() string {
	return fmt.Sprintf("[PUT /contacts][%d] putContactsOK  %+v", 200, o.Payload)
}

func (o *PutContactsOK) GetPayload() *sfgate_models.ContactResponse {
	return o.Payload
}

func (o *PutContactsOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(sfgate_models.ContactResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPutContactsUnauthorized creates a PutContactsUnauthorized with default headers values
func NewPutContactsUnauthorized() *PutContactsUnauthorized {
	return &PutContactsUnauthorized{}
}

/*
PutContactsUnauthorized describes a response with status code 401, with default header values.

Access unauthorized, invalid API-KEY was used
*/
type PutContactsUnauthorized struct {
	Payload *sfgate_models.Error
}

// IsSuccess returns true when this put contacts unauthorized response has a 2xx status code
func (o *PutContactsUnauthorized) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this put contacts unauthorized response has a 3xx status code
func (o *PutContactsUnauthorized) IsRedirect() bool {
	return false
}

// IsClientError returns true when this put contacts unauthorized response has a 4xx status code
func (o *PutContactsUnauthorized) IsClientError() bool {
	return true
}

// IsServerError returns true when this put contacts unauthorized response has a 5xx status code
func (o *PutContactsUnauthorized) IsServerError() bool {
	return false
}

// IsCode returns true when this put contacts unauthorized response a status code equal to that given
func (o *PutContactsUnauthorized) IsCode(code int) bool {
	return code == 401
}

// Code gets the status code for the put contacts unauthorized response
func (o *PutContactsUnauthorized) Code() int {
	return 401
}

func (o *PutContactsUnauthorized) Error() string {
	return fmt.Sprintf("[PUT /contacts][%d] putContactsUnauthorized  %+v", 401, o.Payload)
}

func (o *PutContactsUnauthorized) String() string {
	return fmt.Sprintf("[PUT /contacts][%d] putContactsUnauthorized  %+v", 401, o.Payload)
}

func (o *PutContactsUnauthorized) GetPayload() *sfgate_models.Error {
	return o.Payload
}

func (o *PutContactsUnauthorized) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(sfgate_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPutContactsForbidden creates a PutContactsForbidden with default headers values
func NewPutContactsForbidden() *PutContactsForbidden {
	return &PutContactsForbidden{}
}

/*
PutContactsForbidden describes a response with status code 403, with default header values.

Access forbidden, account lacks access
*/
type PutContactsForbidden struct {
	Payload *sfgate_models.Error
}

// IsSuccess returns true when this put contacts forbidden response has a 2xx status code
func (o *PutContactsForbidden) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this put contacts forbidden response has a 3xx status code
func (o *PutContactsForbidden) IsRedirect() bool {
	return false
}

// IsClientError returns true when this put contacts forbidden response has a 4xx status code
func (o *PutContactsForbidden) IsClientError() bool {
	return true
}

// IsServerError returns true when this put contacts forbidden response has a 5xx status code
func (o *PutContactsForbidden) IsServerError() bool {
	return false
}

// IsCode returns true when this put contacts forbidden response a status code equal to that given
func (o *PutContactsForbidden) IsCode(code int) bool {
	return code == 403
}

// Code gets the status code for the put contacts forbidden response
func (o *PutContactsForbidden) Code() int {
	return 403
}

func (o *PutContactsForbidden) Error() string {
	return fmt.Sprintf("[PUT /contacts][%d] putContactsForbidden  %+v", 403, o.Payload)
}

func (o *PutContactsForbidden) String() string {
	return fmt.Sprintf("[PUT /contacts][%d] putContactsForbidden  %+v", 403, o.Payload)
}

func (o *PutContactsForbidden) GetPayload() *sfgate_models.Error {
	return o.Payload
}

func (o *PutContactsForbidden) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(sfgate_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPutContactsNotFound creates a PutContactsNotFound with default headers values
func NewPutContactsNotFound() *PutContactsNotFound {
	return &PutContactsNotFound{}
}

/*
PutContactsNotFound describes a response with status code 404, with default header values.

Resource was not found
*/
type PutContactsNotFound struct {
	Payload *sfgate_models.Error
}

// IsSuccess returns true when this put contacts not found response has a 2xx status code
func (o *PutContactsNotFound) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this put contacts not found response has a 3xx status code
func (o *PutContactsNotFound) IsRedirect() bool {
	return false
}

// IsClientError returns true when this put contacts not found response has a 4xx status code
func (o *PutContactsNotFound) IsClientError() bool {
	return true
}

// IsServerError returns true when this put contacts not found response has a 5xx status code
func (o *PutContactsNotFound) IsServerError() bool {
	return false
}

// IsCode returns true when this put contacts not found response a status code equal to that given
func (o *PutContactsNotFound) IsCode(code int) bool {
	return code == 404
}

// Code gets the status code for the put contacts not found response
func (o *PutContactsNotFound) Code() int {
	return 404
}

func (o *PutContactsNotFound) Error() string {
	return fmt.Sprintf("[PUT /contacts][%d] putContactsNotFound  %+v", 404, o.Payload)
}

func (o *PutContactsNotFound) String() string {
	return fmt.Sprintf("[PUT /contacts][%d] putContactsNotFound  %+v", 404, o.Payload)
}

func (o *PutContactsNotFound) GetPayload() *sfgate_models.Error {
	return o.Payload
}

func (o *PutContactsNotFound) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(sfgate_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPutContactsUnprocessableEntity creates a PutContactsUnprocessableEntity with default headers values
func NewPutContactsUnprocessableEntity() *PutContactsUnprocessableEntity {
	return &PutContactsUnprocessableEntity{}
}

/*
PutContactsUnprocessableEntity describes a response with status code 422, with default header values.

Unprocessable Entity, likely a bad parameter
*/
type PutContactsUnprocessableEntity struct {
	Payload *sfgate_models.Error
}

// IsSuccess returns true when this put contacts unprocessable entity response has a 2xx status code
func (o *PutContactsUnprocessableEntity) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this put contacts unprocessable entity response has a 3xx status code
func (o *PutContactsUnprocessableEntity) IsRedirect() bool {
	return false
}

// IsClientError returns true when this put contacts unprocessable entity response has a 4xx status code
func (o *PutContactsUnprocessableEntity) IsClientError() bool {
	return true
}

// IsServerError returns true when this put contacts unprocessable entity response has a 5xx status code
func (o *PutContactsUnprocessableEntity) IsServerError() bool {
	return false
}

// IsCode returns true when this put contacts unprocessable entity response a status code equal to that given
func (o *PutContactsUnprocessableEntity) IsCode(code int) bool {
	return code == 422
}

// Code gets the status code for the put contacts unprocessable entity response
func (o *PutContactsUnprocessableEntity) Code() int {
	return 422
}

func (o *PutContactsUnprocessableEntity) Error() string {
	return fmt.Sprintf("[PUT /contacts][%d] putContactsUnprocessableEntity  %+v", 422, o.Payload)
}

func (o *PutContactsUnprocessableEntity) String() string {
	return fmt.Sprintf("[PUT /contacts][%d] putContactsUnprocessableEntity  %+v", 422, o.Payload)
}

func (o *PutContactsUnprocessableEntity) GetPayload() *sfgate_models.Error {
	return o.Payload
}

func (o *PutContactsUnprocessableEntity) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(sfgate_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPutContactsInternalServerError creates a PutContactsInternalServerError with default headers values
func NewPutContactsInternalServerError() *PutContactsInternalServerError {
	return &PutContactsInternalServerError{}
}

/*
PutContactsInternalServerError describes a response with status code 500, with default header values.

Server Internal Error
*/
type PutContactsInternalServerError struct {
	Payload *sfgate_models.Error
}

// IsSuccess returns true when this put contacts internal server error response has a 2xx status code
func (o *PutContactsInternalServerError) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this put contacts internal server error response has a 3xx status code
func (o *PutContactsInternalServerError) IsRedirect() bool {
	return false
}

// IsClientError returns true when this put contacts internal server error response has a 4xx status code
func (o *PutContactsInternalServerError) IsClientError() bool {
	return false
}

// IsServerError returns true when this put contacts internal server error response has a 5xx status code
func (o *PutContactsInternalServerError) IsServerError() bool {
	return true
}

// IsCode returns true when this put contacts internal server error response a status code equal to that given
func (o *PutContactsInternalServerError) IsCode(code int) bool {
	return code == 500
}

// Code gets the status code for the put contacts internal server error response
func (o *PutContactsInternalServerError) Code() int {
	return 500
}

func (o *PutContactsInternalServerError) Error() string {
	return fmt.Sprintf("[PUT /contacts][%d] putContactsInternalServerError  %+v", 500, o.Payload)
}

func (o *PutContactsInternalServerError) String() string {
	return fmt.Sprintf("[PUT /contacts][%d] putContactsInternalServerError  %+v", 500, o.Payload)
}

func (o *PutContactsInternalServerError) GetPayload() *sfgate_models.Error {
	return o.Payload
}

func (o *PutContactsInternalServerError) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(sfgate_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
