// Code generated by go-swagger; DO NOT EDIT.

// (c) 2012-2023 by Vernon Keenan
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package courses

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"

	"code.tnxs.net/work/lib/api/sfgate/sfgate_models"
)

// NewUpdateCourseLessonParams creates a new UpdateCourseLessonParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewUpdateCourseLessonParams() *UpdateCourseLessonParams {
	return &UpdateCourseLessonParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewUpdateCourseLessonParamsWithTimeout creates a new UpdateCourseLessonParams object
// with the ability to set a timeout on a request.
func NewUpdateCourseLessonParamsWithTimeout(timeout time.Duration) *UpdateCourseLessonParams {
	return &UpdateCourseLessonParams{
		timeout: timeout,
	}
}

// NewUpdateCourseLessonParamsWithContext creates a new UpdateCourseLessonParams object
// with the ability to set a context for a request.
func NewUpdateCourseLessonParamsWithContext(ctx context.Context) *UpdateCourseLessonParams {
	return &UpdateCourseLessonParams{
		Context: ctx,
	}
}

// NewUpdateCourseLessonParamsWithHTTPClient creates a new UpdateCourseLessonParams object
// with the ability to set a custom HTTPClient for a request.
func NewUpdateCourseLessonParamsWithHTTPClient(client *http.Client) *UpdateCourseLessonParams {
	return &UpdateCourseLessonParams{
		HTTPClient: client,
	}
}

/*
UpdateCourseLessonParams contains all the parameters to send to the API endpoint

	for the update course lesson operation.

	Typically these are written to a http.Request.
*/
type UpdateCourseLessonParams struct {

	/* CourselessonRequest.

	   An array of new CourseLesson records
	*/
	CourselessonRequest *sfgate_models.CourseLessonRequest

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the update course lesson params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *UpdateCourseLessonParams) WithDefaults() *UpdateCourseLessonParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the update course lesson params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *UpdateCourseLessonParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the update course lesson params
func (o *UpdateCourseLessonParams) WithTimeout(timeout time.Duration) *UpdateCourseLessonParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the update course lesson params
func (o *UpdateCourseLessonParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the update course lesson params
func (o *UpdateCourseLessonParams) WithContext(ctx context.Context) *UpdateCourseLessonParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the update course lesson params
func (o *UpdateCourseLessonParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the update course lesson params
func (o *UpdateCourseLessonParams) WithHTTPClient(client *http.Client) *UpdateCourseLessonParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the update course lesson params
func (o *UpdateCourseLessonParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithCourselessonRequest adds the courselessonRequest to the update course lesson params
func (o *UpdateCourseLessonParams) WithCourselessonRequest(courselessonRequest *sfgate_models.CourseLessonRequest) *UpdateCourseLessonParams {
	o.SetCourselessonRequest(courselessonRequest)
	return o
}

// SetCourselessonRequest adds the courselessonRequest to the update course lesson params
func (o *UpdateCourseLessonParams) SetCourselessonRequest(courselessonRequest *sfgate_models.CourseLessonRequest) {
	o.CourselessonRequest = courselessonRequest
}

// WriteToRequest writes these params to a swagger request
func (o *UpdateCourseLessonParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error
	if o.CourselessonRequest != nil {
		if err := r.SetBodyParam(o.CourselessonRequest); err != nil {
			return err
		}
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
