// Code generated by go-swagger; DO NOT EDIT.

// (c) 2012-2023 by Vernon Keenan
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package courses

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"

	"code.tnxs.net/work/lib/api/sfgate/sfgate_models"
)

// NewUpdateCourseSectionParams creates a new UpdateCourseSectionParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewUpdateCourseSectionParams() *UpdateCourseSectionParams {
	return &UpdateCourseSectionParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewUpdateCourseSectionParamsWithTimeout creates a new UpdateCourseSectionParams object
// with the ability to set a timeout on a request.
func NewUpdateCourseSectionParamsWithTimeout(timeout time.Duration) *UpdateCourseSectionParams {
	return &UpdateCourseSectionParams{
		timeout: timeout,
	}
}

// NewUpdateCourseSectionParamsWithContext creates a new UpdateCourseSectionParams object
// with the ability to set a context for a request.
func NewUpdateCourseSectionParamsWithContext(ctx context.Context) *UpdateCourseSectionParams {
	return &UpdateCourseSectionParams{
		Context: ctx,
	}
}

// NewUpdateCourseSectionParamsWithHTTPClient creates a new UpdateCourseSectionParams object
// with the ability to set a custom HTTPClient for a request.
func NewUpdateCourseSectionParamsWithHTTPClient(client *http.Client) *UpdateCourseSectionParams {
	return &UpdateCourseSectionParams{
		HTTPClient: client,
	}
}

/*
UpdateCourseSectionParams contains all the parameters to send to the API endpoint

	for the update course section operation.

	Typically these are written to a http.Request.
*/
type UpdateCourseSectionParams struct {

	/* CoursesectionRequest.

	   An array of new CourseSection records
	*/
	CoursesectionRequest *sfgate_models.CourseSectionRequest

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the update course section params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *UpdateCourseSectionParams) WithDefaults() *UpdateCourseSectionParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the update course section params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *UpdateCourseSectionParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the update course section params
func (o *UpdateCourseSectionParams) WithTimeout(timeout time.Duration) *UpdateCourseSectionParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the update course section params
func (o *UpdateCourseSectionParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the update course section params
func (o *UpdateCourseSectionParams) WithContext(ctx context.Context) *UpdateCourseSectionParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the update course section params
func (o *UpdateCourseSectionParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the update course section params
func (o *UpdateCourseSectionParams) WithHTTPClient(client *http.Client) *UpdateCourseSectionParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the update course section params
func (o *UpdateCourseSectionParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithCoursesectionRequest adds the coursesectionRequest to the update course section params
func (o *UpdateCourseSectionParams) WithCoursesectionRequest(coursesectionRequest *sfgate_models.CourseSectionRequest) *UpdateCourseSectionParams {
	o.SetCoursesectionRequest(coursesectionRequest)
	return o
}

// SetCoursesectionRequest adds the coursesectionRequest to the update course section params
func (o *UpdateCourseSectionParams) SetCoursesectionRequest(coursesectionRequest *sfgate_models.CourseSectionRequest) {
	o.CoursesectionRequest = coursesectionRequest
}

// WriteToRequest writes these params to a swagger request
func (o *UpdateCourseSectionParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error
	if o.CoursesectionRequest != nil {
		if err := r.SetBodyParam(o.CoursesectionRequest); err != nil {
			return err
		}
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
