// Code generated by go-swagger; DO NOT EDIT.

// (c) 2012-2023 by Vernon Keenan
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package databases

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"

	"code.tnxs.net/work/lib/api/sfgate/sfgate_models"
)

// PostDatabasesReader is a Reader for the PostDatabases structure.
type PostDatabasesReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *PostDatabasesReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 201:
		result := NewPostDatabasesCreated()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 401:
		result := NewPostDatabasesUnauthorized()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 403:
		result := NewPostDatabasesForbidden()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 404:
		result := NewPostDatabasesNotFound()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 422:
		result := NewPostDatabasesUnprocessableEntity()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 500:
		result := NewPostDatabasesInternalServerError()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		return nil, runtime.NewAPIError("response status code does not match any response statuses defined for this endpoint in the swagger spec", response, response.Code())
	}
}

// NewPostDatabasesCreated creates a PostDatabasesCreated with default headers values
func NewPostDatabasesCreated() *PostDatabasesCreated {
	return &PostDatabasesCreated{}
}

/*
PostDatabasesCreated describes a response with status code 201, with default header values.

Response from Salesforce
*/
type PostDatabasesCreated struct {
	Payload *sfgate_models.SalesforcePostResponse
}

// IsSuccess returns true when this post databases created response has a 2xx status code
func (o *PostDatabasesCreated) IsSuccess() bool {
	return true
}

// IsRedirect returns true when this post databases created response has a 3xx status code
func (o *PostDatabasesCreated) IsRedirect() bool {
	return false
}

// IsClientError returns true when this post databases created response has a 4xx status code
func (o *PostDatabasesCreated) IsClientError() bool {
	return false
}

// IsServerError returns true when this post databases created response has a 5xx status code
func (o *PostDatabasesCreated) IsServerError() bool {
	return false
}

// IsCode returns true when this post databases created response a status code equal to that given
func (o *PostDatabasesCreated) IsCode(code int) bool {
	return code == 201
}

// Code gets the status code for the post databases created response
func (o *PostDatabasesCreated) Code() int {
	return 201
}

func (o *PostDatabasesCreated) Error() string {
	return fmt.Sprintf("[POST /databases][%d] postDatabasesCreated  %+v", 201, o.Payload)
}

func (o *PostDatabasesCreated) String() string {
	return fmt.Sprintf("[POST /databases][%d] postDatabasesCreated  %+v", 201, o.Payload)
}

func (o *PostDatabasesCreated) GetPayload() *sfgate_models.SalesforcePostResponse {
	return o.Payload
}

func (o *PostDatabasesCreated) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(sfgate_models.SalesforcePostResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPostDatabasesUnauthorized creates a PostDatabasesUnauthorized with default headers values
func NewPostDatabasesUnauthorized() *PostDatabasesUnauthorized {
	return &PostDatabasesUnauthorized{}
}

/*
PostDatabasesUnauthorized describes a response with status code 401, with default header values.

Access unauthorized, invalid API-KEY was used
*/
type PostDatabasesUnauthorized struct {
	Payload *sfgate_models.Error
}

// IsSuccess returns true when this post databases unauthorized response has a 2xx status code
func (o *PostDatabasesUnauthorized) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this post databases unauthorized response has a 3xx status code
func (o *PostDatabasesUnauthorized) IsRedirect() bool {
	return false
}

// IsClientError returns true when this post databases unauthorized response has a 4xx status code
func (o *PostDatabasesUnauthorized) IsClientError() bool {
	return true
}

// IsServerError returns true when this post databases unauthorized response has a 5xx status code
func (o *PostDatabasesUnauthorized) IsServerError() bool {
	return false
}

// IsCode returns true when this post databases unauthorized response a status code equal to that given
func (o *PostDatabasesUnauthorized) IsCode(code int) bool {
	return code == 401
}

// Code gets the status code for the post databases unauthorized response
func (o *PostDatabasesUnauthorized) Code() int {
	return 401
}

func (o *PostDatabasesUnauthorized) Error() string {
	return fmt.Sprintf("[POST /databases][%d] postDatabasesUnauthorized  %+v", 401, o.Payload)
}

func (o *PostDatabasesUnauthorized) String() string {
	return fmt.Sprintf("[POST /databases][%d] postDatabasesUnauthorized  %+v", 401, o.Payload)
}

func (o *PostDatabasesUnauthorized) GetPayload() *sfgate_models.Error {
	return o.Payload
}

func (o *PostDatabasesUnauthorized) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(sfgate_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPostDatabasesForbidden creates a PostDatabasesForbidden with default headers values
func NewPostDatabasesForbidden() *PostDatabasesForbidden {
	return &PostDatabasesForbidden{}
}

/*
PostDatabasesForbidden describes a response with status code 403, with default header values.

Access forbidden, account lacks access
*/
type PostDatabasesForbidden struct {
	Payload *sfgate_models.Error
}

// IsSuccess returns true when this post databases forbidden response has a 2xx status code
func (o *PostDatabasesForbidden) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this post databases forbidden response has a 3xx status code
func (o *PostDatabasesForbidden) IsRedirect() bool {
	return false
}

// IsClientError returns true when this post databases forbidden response has a 4xx status code
func (o *PostDatabasesForbidden) IsClientError() bool {
	return true
}

// IsServerError returns true when this post databases forbidden response has a 5xx status code
func (o *PostDatabasesForbidden) IsServerError() bool {
	return false
}

// IsCode returns true when this post databases forbidden response a status code equal to that given
func (o *PostDatabasesForbidden) IsCode(code int) bool {
	return code == 403
}

// Code gets the status code for the post databases forbidden response
func (o *PostDatabasesForbidden) Code() int {
	return 403
}

func (o *PostDatabasesForbidden) Error() string {
	return fmt.Sprintf("[POST /databases][%d] postDatabasesForbidden  %+v", 403, o.Payload)
}

func (o *PostDatabasesForbidden) String() string {
	return fmt.Sprintf("[POST /databases][%d] postDatabasesForbidden  %+v", 403, o.Payload)
}

func (o *PostDatabasesForbidden) GetPayload() *sfgate_models.Error {
	return o.Payload
}

func (o *PostDatabasesForbidden) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(sfgate_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPostDatabasesNotFound creates a PostDatabasesNotFound with default headers values
func NewPostDatabasesNotFound() *PostDatabasesNotFound {
	return &PostDatabasesNotFound{}
}

/*
PostDatabasesNotFound describes a response with status code 404, with default header values.

Resource was not found
*/
type PostDatabasesNotFound struct {
	Payload *sfgate_models.Error
}

// IsSuccess returns true when this post databases not found response has a 2xx status code
func (o *PostDatabasesNotFound) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this post databases not found response has a 3xx status code
func (o *PostDatabasesNotFound) IsRedirect() bool {
	return false
}

// IsClientError returns true when this post databases not found response has a 4xx status code
func (o *PostDatabasesNotFound) IsClientError() bool {
	return true
}

// IsServerError returns true when this post databases not found response has a 5xx status code
func (o *PostDatabasesNotFound) IsServerError() bool {
	return false
}

// IsCode returns true when this post databases not found response a status code equal to that given
func (o *PostDatabasesNotFound) IsCode(code int) bool {
	return code == 404
}

// Code gets the status code for the post databases not found response
func (o *PostDatabasesNotFound) Code() int {
	return 404
}

func (o *PostDatabasesNotFound) Error() string {
	return fmt.Sprintf("[POST /databases][%d] postDatabasesNotFound  %+v", 404, o.Payload)
}

func (o *PostDatabasesNotFound) String() string {
	return fmt.Sprintf("[POST /databases][%d] postDatabasesNotFound  %+v", 404, o.Payload)
}

func (o *PostDatabasesNotFound) GetPayload() *sfgate_models.Error {
	return o.Payload
}

func (o *PostDatabasesNotFound) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(sfgate_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPostDatabasesUnprocessableEntity creates a PostDatabasesUnprocessableEntity with default headers values
func NewPostDatabasesUnprocessableEntity() *PostDatabasesUnprocessableEntity {
	return &PostDatabasesUnprocessableEntity{}
}

/*
PostDatabasesUnprocessableEntity describes a response with status code 422, with default header values.

Unprocessable Entity, likely a bad parameter
*/
type PostDatabasesUnprocessableEntity struct {
	Payload *sfgate_models.Error
}

// IsSuccess returns true when this post databases unprocessable entity response has a 2xx status code
func (o *PostDatabasesUnprocessableEntity) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this post databases unprocessable entity response has a 3xx status code
func (o *PostDatabasesUnprocessableEntity) IsRedirect() bool {
	return false
}

// IsClientError returns true when this post databases unprocessable entity response has a 4xx status code
func (o *PostDatabasesUnprocessableEntity) IsClientError() bool {
	return true
}

// IsServerError returns true when this post databases unprocessable entity response has a 5xx status code
func (o *PostDatabasesUnprocessableEntity) IsServerError() bool {
	return false
}

// IsCode returns true when this post databases unprocessable entity response a status code equal to that given
func (o *PostDatabasesUnprocessableEntity) IsCode(code int) bool {
	return code == 422
}

// Code gets the status code for the post databases unprocessable entity response
func (o *PostDatabasesUnprocessableEntity) Code() int {
	return 422
}

func (o *PostDatabasesUnprocessableEntity) Error() string {
	return fmt.Sprintf("[POST /databases][%d] postDatabasesUnprocessableEntity  %+v", 422, o.Payload)
}

func (o *PostDatabasesUnprocessableEntity) String() string {
	return fmt.Sprintf("[POST /databases][%d] postDatabasesUnprocessableEntity  %+v", 422, o.Payload)
}

func (o *PostDatabasesUnprocessableEntity) GetPayload() *sfgate_models.Error {
	return o.Payload
}

func (o *PostDatabasesUnprocessableEntity) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(sfgate_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPostDatabasesInternalServerError creates a PostDatabasesInternalServerError with default headers values
func NewPostDatabasesInternalServerError() *PostDatabasesInternalServerError {
	return &PostDatabasesInternalServerError{}
}

/*
PostDatabasesInternalServerError describes a response with status code 500, with default header values.

Server Internal Error
*/
type PostDatabasesInternalServerError struct {
	Payload *sfgate_models.Error
}

// IsSuccess returns true when this post databases internal server error response has a 2xx status code
func (o *PostDatabasesInternalServerError) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this post databases internal server error response has a 3xx status code
func (o *PostDatabasesInternalServerError) IsRedirect() bool {
	return false
}

// IsClientError returns true when this post databases internal server error response has a 4xx status code
func (o *PostDatabasesInternalServerError) IsClientError() bool {
	return false
}

// IsServerError returns true when this post databases internal server error response has a 5xx status code
func (o *PostDatabasesInternalServerError) IsServerError() bool {
	return true
}

// IsCode returns true when this post databases internal server error response a status code equal to that given
func (o *PostDatabasesInternalServerError) IsCode(code int) bool {
	return code == 500
}

// Code gets the status code for the post databases internal server error response
func (o *PostDatabasesInternalServerError) Code() int {
	return 500
}

func (o *PostDatabasesInternalServerError) Error() string {
	return fmt.Sprintf("[POST /databases][%d] postDatabasesInternalServerError  %+v", 500, o.Payload)
}

func (o *PostDatabasesInternalServerError) String() string {
	return fmt.Sprintf("[POST /databases][%d] postDatabasesInternalServerError  %+v", 500, o.Payload)
}

func (o *PostDatabasesInternalServerError) GetPayload() *sfgate_models.Error {
	return o.Payload
}

func (o *PostDatabasesInternalServerError) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(sfgate_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
