// Code generated by go-swagger; DO NOT EDIT.

// (c) 2012-2023 by Vernon Keenan
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package documents

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"
)

// New creates a new documents API client.
func New(transport runtime.ClientTransport, formats strfmt.Registry) ClientService {
	return &Client{transport: transport, formats: formats}
}

/*
Client for documents API
*/
type Client struct {
	transport runtime.ClientTransport
	formats   strfmt.Registry
}

// ClientOption is the option for Client methods
type ClientOption func(*runtime.ClientOperation)

// ClientService is the interface for Client methods
type ClientService interface {
	GetDocuments(params *GetDocumentsParams, authInfo runtime.ClientAuthInfoWriter, opts ...ClientOption) (*GetDocumentsOK, error)

	PostDocuments(params *PostDocumentsParams, authInfo runtime.ClientAuthInfoWriter, opts ...ClientOption) (*PostDocumentsCreated, error)

	PutDocuments(params *PutDocumentsParams, authInfo runtime.ClientAuthInfoWriter, opts ...ClientOption) (*PutDocumentsOK, error)

	SetTransport(transport runtime.ClientTransport)
}

/*
GetDocuments gets a list documents

Return a list of Document records from the datastore
*/
func (a *Client) GetDocuments(params *GetDocumentsParams, authInfo runtime.ClientAuthInfoWriter, opts ...ClientOption) (*GetDocumentsOK, error) {
	// TODO: Validate the params before sending
	if params == nil {
		params = NewGetDocumentsParams()
	}
	op := &runtime.ClientOperation{
		ID:                 "getDocuments",
		Method:             "GET",
		PathPattern:        "/documents",
		ProducesMediaTypes: []string{"application/json"},
		ConsumesMediaTypes: []string{"application/json"},
		Schemes:            []string{"http"},
		Params:             params,
		Reader:             &GetDocumentsReader{formats: a.formats},
		AuthInfo:           authInfo,
		Context:            params.Context,
		Client:             params.HTTPClient,
	}
	for _, opt := range opts {
		opt(op)
	}

	result, err := a.transport.Submit(op)
	if err != nil {
		return nil, err
	}
	success, ok := result.(*GetDocumentsOK)
	if ok {
		return success, nil
	}
	// unexpected success response
	// safeguard: normally, absent a default response, unknown success responses return an error above: so this is a codegen issue
	msg := fmt.Sprintf("unexpected success response for getDocuments: API contract not enforced by server. Client expected to get an error, but got: %T", result)
	panic(msg)
}

/*
PostDocuments creates new documents

Create Documents in Salesforce
*/
func (a *Client) PostDocuments(params *PostDocumentsParams, authInfo runtime.ClientAuthInfoWriter, opts ...ClientOption) (*PostDocumentsCreated, error) {
	// TODO: Validate the params before sending
	if params == nil {
		params = NewPostDocumentsParams()
	}
	op := &runtime.ClientOperation{
		ID:                 "postDocuments",
		Method:             "POST",
		PathPattern:        "/documents",
		ProducesMediaTypes: []string{"application/json"},
		ConsumesMediaTypes: []string{"application/json"},
		Schemes:            []string{"http"},
		Params:             params,
		Reader:             &PostDocumentsReader{formats: a.formats},
		AuthInfo:           authInfo,
		Context:            params.Context,
		Client:             params.HTTPClient,
	}
	for _, opt := range opts {
		opt(op)
	}

	result, err := a.transport.Submit(op)
	if err != nil {
		return nil, err
	}
	success, ok := result.(*PostDocumentsCreated)
	if ok {
		return success, nil
	}
	// unexpected success response
	// safeguard: normally, absent a default response, unknown success responses return an error above: so this is a codegen issue
	msg := fmt.Sprintf("unexpected success response for postDocuments: API contract not enforced by server. Client expected to get an error, but got: %T", result)
	panic(msg)
}

/*
PutDocuments updates documents

Update Document in Salesforce
*/
func (a *Client) PutDocuments(params *PutDocumentsParams, authInfo runtime.ClientAuthInfoWriter, opts ...ClientOption) (*PutDocumentsOK, error) {
	// TODO: Validate the params before sending
	if params == nil {
		params = NewPutDocumentsParams()
	}
	op := &runtime.ClientOperation{
		ID:                 "putDocuments",
		Method:             "PUT",
		PathPattern:        "/documents",
		ProducesMediaTypes: []string{"application/json"},
		ConsumesMediaTypes: []string{"application/json"},
		Schemes:            []string{"http"},
		Params:             params,
		Reader:             &PutDocumentsReader{formats: a.formats},
		AuthInfo:           authInfo,
		Context:            params.Context,
		Client:             params.HTTPClient,
	}
	for _, opt := range opts {
		opt(op)
	}

	result, err := a.transport.Submit(op)
	if err != nil {
		return nil, err
	}
	success, ok := result.(*PutDocumentsOK)
	if ok {
		return success, nil
	}
	// unexpected success response
	// safeguard: normally, absent a default response, unknown success responses return an error above: so this is a codegen issue
	msg := fmt.Sprintf("unexpected success response for putDocuments: API contract not enforced by server. Client expected to get an error, but got: %T", result)
	panic(msg)
}

// SetTransport changes the transport on the client
func (a *Client) SetTransport(transport runtime.ClientTransport) {
	a.transport = transport
}
