// Code generated by go-swagger; DO NOT EDIT.

// (c) 2012-2023 by Vernon Keenan
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package factors

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
)

// NewGetFactorsParams creates a new GetFactorsParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewGetFactorsParams() *GetFactorsParams {
	return &GetFactorsParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewGetFactorsParamsWithTimeout creates a new GetFactorsParams object
// with the ability to set a timeout on a request.
func NewGetFactorsParamsWithTimeout(timeout time.Duration) *GetFactorsParams {
	return &GetFactorsParams{
		timeout: timeout,
	}
}

// NewGetFactorsParamsWithContext creates a new GetFactorsParams object
// with the ability to set a context for a request.
func NewGetFactorsParamsWithContext(ctx context.Context) *GetFactorsParams {
	return &GetFactorsParams{
		Context: ctx,
	}
}

// NewGetFactorsParamsWithHTTPClient creates a new GetFactorsParams object
// with the ability to set a custom HTTPClient for a request.
func NewGetFactorsParamsWithHTTPClient(client *http.Client) *GetFactorsParams {
	return &GetFactorsParams{
		HTTPClient: client,
	}
}

/*
GetFactorsParams contains all the parameters to send to the API endpoint

	for the get factors operation.

	Typically these are written to a http.Request.
*/
type GetFactorsParams struct {

	/* Active.

	   Only retrieve active records?
	*/
	Active *bool

	/* FactorID.

	   Record Id of a Factor
	*/
	FactorID *string

	/* Limit.

	   How many objects to return at one time

	   Format: int64
	*/
	Limit *int64

	/* Offset.

	   How many objects to skip?

	   Format: int64
	*/
	Offset *int64

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the get factors params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *GetFactorsParams) WithDefaults() *GetFactorsParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the get factors params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *GetFactorsParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the get factors params
func (o *GetFactorsParams) WithTimeout(timeout time.Duration) *GetFactorsParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the get factors params
func (o *GetFactorsParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the get factors params
func (o *GetFactorsParams) WithContext(ctx context.Context) *GetFactorsParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the get factors params
func (o *GetFactorsParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the get factors params
func (o *GetFactorsParams) WithHTTPClient(client *http.Client) *GetFactorsParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the get factors params
func (o *GetFactorsParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithActive adds the active to the get factors params
func (o *GetFactorsParams) WithActive(active *bool) *GetFactorsParams {
	o.SetActive(active)
	return o
}

// SetActive adds the active to the get factors params
func (o *GetFactorsParams) SetActive(active *bool) {
	o.Active = active
}

// WithFactorID adds the factorID to the get factors params
func (o *GetFactorsParams) WithFactorID(factorID *string) *GetFactorsParams {
	o.SetFactorID(factorID)
	return o
}

// SetFactorID adds the factorId to the get factors params
func (o *GetFactorsParams) SetFactorID(factorID *string) {
	o.FactorID = factorID
}

// WithLimit adds the limit to the get factors params
func (o *GetFactorsParams) WithLimit(limit *int64) *GetFactorsParams {
	o.SetLimit(limit)
	return o
}

// SetLimit adds the limit to the get factors params
func (o *GetFactorsParams) SetLimit(limit *int64) {
	o.Limit = limit
}

// WithOffset adds the offset to the get factors params
func (o *GetFactorsParams) WithOffset(offset *int64) *GetFactorsParams {
	o.SetOffset(offset)
	return o
}

// SetOffset adds the offset to the get factors params
func (o *GetFactorsParams) SetOffset(offset *int64) {
	o.Offset = offset
}

// WriteToRequest writes these params to a swagger request
func (o *GetFactorsParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	if o.Active != nil {

		// query param active
		var qrActive bool

		if o.Active != nil {
			qrActive = *o.Active
		}
		qActive := swag.FormatBool(qrActive)
		if qActive != "" {

			if err := r.SetQueryParam("active", qActive); err != nil {
				return err
			}
		}
	}

	if o.FactorID != nil {

		// query param factorId
		var qrFactorID string

		if o.FactorID != nil {
			qrFactorID = *o.FactorID
		}
		qFactorID := qrFactorID
		if qFactorID != "" {

			if err := r.SetQueryParam("factorId", qFactorID); err != nil {
				return err
			}
		}
	}

	if o.Limit != nil {

		// query param limit
		var qrLimit int64

		if o.Limit != nil {
			qrLimit = *o.Limit
		}
		qLimit := swag.FormatInt64(qrLimit)
		if qLimit != "" {

			if err := r.SetQueryParam("limit", qLimit); err != nil {
				return err
			}
		}
	}

	if o.Offset != nil {

		// query param offset
		var qrOffset int64

		if o.Offset != nil {
			qrOffset = *o.Offset
		}
		qOffset := swag.FormatInt64(qrOffset)
		if qOffset != "" {

			if err := r.SetQueryParam("offset", qOffset); err != nil {
				return err
			}
		}
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
