// Code generated by go-swagger; DO NOT EDIT.

// (c) 2012-2023 by Vernon Keenan
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package factors

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"

	"code.tnxs.net/work/lib/api/sfgate/sfgate_models"
)

// NewPostFactorsParams creates a new PostFactorsParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewPostFactorsParams() *PostFactorsParams {
	return &PostFactorsParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewPostFactorsParamsWithTimeout creates a new PostFactorsParams object
// with the ability to set a timeout on a request.
func NewPostFactorsParamsWithTimeout(timeout time.Duration) *PostFactorsParams {
	return &PostFactorsParams{
		timeout: timeout,
	}
}

// NewPostFactorsParamsWithContext creates a new PostFactorsParams object
// with the ability to set a context for a request.
func NewPostFactorsParamsWithContext(ctx context.Context) *PostFactorsParams {
	return &PostFactorsParams{
		Context: ctx,
	}
}

// NewPostFactorsParamsWithHTTPClient creates a new PostFactorsParams object
// with the ability to set a custom HTTPClient for a request.
func NewPostFactorsParamsWithHTTPClient(client *http.Client) *PostFactorsParams {
	return &PostFactorsParams{
		HTTPClient: client,
	}
}

/*
PostFactorsParams contains all the parameters to send to the API endpoint

	for the post factors operation.

	Typically these are written to a http.Request.
*/
type PostFactorsParams struct {

	/* FactorRequest.

	   A request with an array of Factor Objects
	*/
	FactorRequest *sfgate_models.FactorRequest

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the post factors params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *PostFactorsParams) WithDefaults() *PostFactorsParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the post factors params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *PostFactorsParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the post factors params
func (o *PostFactorsParams) WithTimeout(timeout time.Duration) *PostFactorsParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the post factors params
func (o *PostFactorsParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the post factors params
func (o *PostFactorsParams) WithContext(ctx context.Context) *PostFactorsParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the post factors params
func (o *PostFactorsParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the post factors params
func (o *PostFactorsParams) WithHTTPClient(client *http.Client) *PostFactorsParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the post factors params
func (o *PostFactorsParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithFactorRequest adds the factorRequest to the post factors params
func (o *PostFactorsParams) WithFactorRequest(factorRequest *sfgate_models.FactorRequest) *PostFactorsParams {
	o.SetFactorRequest(factorRequest)
	return o
}

// SetFactorRequest adds the factorRequest to the post factors params
func (o *PostFactorsParams) SetFactorRequest(factorRequest *sfgate_models.FactorRequest) {
	o.FactorRequest = factorRequest
}

// WriteToRequest writes these params to a swagger request
func (o *PostFactorsParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error
	if o.FactorRequest != nil {
		if err := r.SetBodyParam(o.FactorRequest); err != nil {
			return err
		}
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
