// Code generated by go-swagger; DO NOT EDIT.

// (c) 2012-2023 by Vernon Keenan
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package financial_statements

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
)

// NewGetFinancialStatementsParams creates a new GetFinancialStatementsParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewGetFinancialStatementsParams() *GetFinancialStatementsParams {
	return &GetFinancialStatementsParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewGetFinancialStatementsParamsWithTimeout creates a new GetFinancialStatementsParams object
// with the ability to set a timeout on a request.
func NewGetFinancialStatementsParamsWithTimeout(timeout time.Duration) *GetFinancialStatementsParams {
	return &GetFinancialStatementsParams{
		timeout: timeout,
	}
}

// NewGetFinancialStatementsParamsWithContext creates a new GetFinancialStatementsParams object
// with the ability to set a context for a request.
func NewGetFinancialStatementsParamsWithContext(ctx context.Context) *GetFinancialStatementsParams {
	return &GetFinancialStatementsParams{
		Context: ctx,
	}
}

// NewGetFinancialStatementsParamsWithHTTPClient creates a new GetFinancialStatementsParams object
// with the ability to set a custom HTTPClient for a request.
func NewGetFinancialStatementsParamsWithHTTPClient(client *http.Client) *GetFinancialStatementsParams {
	return &GetFinancialStatementsParams{
		HTTPClient: client,
	}
}

/*
GetFinancialStatementsParams contains all the parameters to send to the API endpoint

	for the get financial statements operation.

	Typically these are written to a http.Request.
*/
type GetFinancialStatementsParams struct {

	/* Active.

	   Only retrieve active records?
	*/
	Active *bool

	/* FinancialStatementID.

	   Record Id of a FinancialStatement
	*/
	FinancialStatementID *string

	/* Limit.

	   How many objects to return at one time

	   Format: int64
	*/
	Limit *int64

	/* Offset.

	   How many objects to skip?

	   Format: int64
	*/
	Offset *int64

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the get financial statements params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *GetFinancialStatementsParams) WithDefaults() *GetFinancialStatementsParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the get financial statements params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *GetFinancialStatementsParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the get financial statements params
func (o *GetFinancialStatementsParams) WithTimeout(timeout time.Duration) *GetFinancialStatementsParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the get financial statements params
func (o *GetFinancialStatementsParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the get financial statements params
func (o *GetFinancialStatementsParams) WithContext(ctx context.Context) *GetFinancialStatementsParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the get financial statements params
func (o *GetFinancialStatementsParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the get financial statements params
func (o *GetFinancialStatementsParams) WithHTTPClient(client *http.Client) *GetFinancialStatementsParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the get financial statements params
func (o *GetFinancialStatementsParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithActive adds the active to the get financial statements params
func (o *GetFinancialStatementsParams) WithActive(active *bool) *GetFinancialStatementsParams {
	o.SetActive(active)
	return o
}

// SetActive adds the active to the get financial statements params
func (o *GetFinancialStatementsParams) SetActive(active *bool) {
	o.Active = active
}

// WithFinancialStatementID adds the financialStatementID to the get financial statements params
func (o *GetFinancialStatementsParams) WithFinancialStatementID(financialStatementID *string) *GetFinancialStatementsParams {
	o.SetFinancialStatementID(financialStatementID)
	return o
}

// SetFinancialStatementID adds the financialStatementId to the get financial statements params
func (o *GetFinancialStatementsParams) SetFinancialStatementID(financialStatementID *string) {
	o.FinancialStatementID = financialStatementID
}

// WithLimit adds the limit to the get financial statements params
func (o *GetFinancialStatementsParams) WithLimit(limit *int64) *GetFinancialStatementsParams {
	o.SetLimit(limit)
	return o
}

// SetLimit adds the limit to the get financial statements params
func (o *GetFinancialStatementsParams) SetLimit(limit *int64) {
	o.Limit = limit
}

// WithOffset adds the offset to the get financial statements params
func (o *GetFinancialStatementsParams) WithOffset(offset *int64) *GetFinancialStatementsParams {
	o.SetOffset(offset)
	return o
}

// SetOffset adds the offset to the get financial statements params
func (o *GetFinancialStatementsParams) SetOffset(offset *int64) {
	o.Offset = offset
}

// WriteToRequest writes these params to a swagger request
func (o *GetFinancialStatementsParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	if o.Active != nil {

		// query param active
		var qrActive bool

		if o.Active != nil {
			qrActive = *o.Active
		}
		qActive := swag.FormatBool(qrActive)
		if qActive != "" {

			if err := r.SetQueryParam("active", qActive); err != nil {
				return err
			}
		}
	}

	if o.FinancialStatementID != nil {

		// query param financialStatementId
		var qrFinancialStatementID string

		if o.FinancialStatementID != nil {
			qrFinancialStatementID = *o.FinancialStatementID
		}
		qFinancialStatementID := qrFinancialStatementID
		if qFinancialStatementID != "" {

			if err := r.SetQueryParam("financialStatementId", qFinancialStatementID); err != nil {
				return err
			}
		}
	}

	if o.Limit != nil {

		// query param limit
		var qrLimit int64

		if o.Limit != nil {
			qrLimit = *o.Limit
		}
		qLimit := swag.FormatInt64(qrLimit)
		if qLimit != "" {

			if err := r.SetQueryParam("limit", qLimit); err != nil {
				return err
			}
		}
	}

	if o.Offset != nil {

		// query param offset
		var qrOffset int64

		if o.Offset != nil {
			qrOffset = *o.Offset
		}
		qOffset := swag.FormatInt64(qrOffset)
		if qOffset != "" {

			if err := r.SetQueryParam("offset", qOffset); err != nil {
				return err
			}
		}
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
