// Code generated by go-swagger; DO NOT EDIT.

// (c) 2012-2023 by Vernon Keenan
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package industry_companies

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"

	"code.tnxs.net/work/lib/api/sfgate/sfgate_models"
)

// GetIndustryCompaniesReader is a Reader for the GetIndustryCompanies structure.
type GetIndustryCompaniesReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *GetIndustryCompaniesReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewGetIndustryCompaniesOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 401:
		result := NewGetIndustryCompaniesUnauthorized()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 403:
		result := NewGetIndustryCompaniesForbidden()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 404:
		result := NewGetIndustryCompaniesNotFound()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 422:
		result := NewGetIndustryCompaniesUnprocessableEntity()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 500:
		result := NewGetIndustryCompaniesInternalServerError()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		return nil, runtime.NewAPIError("response status code does not match any response statuses defined for this endpoint in the swagger spec", response, response.Code())
	}
}

// NewGetIndustryCompaniesOK creates a GetIndustryCompaniesOK with default headers values
func NewGetIndustryCompaniesOK() *GetIndustryCompaniesOK {
	return &GetIndustryCompaniesOK{}
}

/*
GetIndustryCompaniesOK describes a response with status code 200, with default header values.

Response with IndustryCompany objects
*/
type GetIndustryCompaniesOK struct {
	Payload *sfgate_models.IndustryCompanyResponse
}

// IsSuccess returns true when this get industry companies o k response has a 2xx status code
func (o *GetIndustryCompaniesOK) IsSuccess() bool {
	return true
}

// IsRedirect returns true when this get industry companies o k response has a 3xx status code
func (o *GetIndustryCompaniesOK) IsRedirect() bool {
	return false
}

// IsClientError returns true when this get industry companies o k response has a 4xx status code
func (o *GetIndustryCompaniesOK) IsClientError() bool {
	return false
}

// IsServerError returns true when this get industry companies o k response has a 5xx status code
func (o *GetIndustryCompaniesOK) IsServerError() bool {
	return false
}

// IsCode returns true when this get industry companies o k response a status code equal to that given
func (o *GetIndustryCompaniesOK) IsCode(code int) bool {
	return code == 200
}

// Code gets the status code for the get industry companies o k response
func (o *GetIndustryCompaniesOK) Code() int {
	return 200
}

func (o *GetIndustryCompaniesOK) Error() string {
	return fmt.Sprintf("[GET /industrycompanies][%d] getIndustryCompaniesOK  %+v", 200, o.Payload)
}

func (o *GetIndustryCompaniesOK) String() string {
	return fmt.Sprintf("[GET /industrycompanies][%d] getIndustryCompaniesOK  %+v", 200, o.Payload)
}

func (o *GetIndustryCompaniesOK) GetPayload() *sfgate_models.IndustryCompanyResponse {
	return o.Payload
}

func (o *GetIndustryCompaniesOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(sfgate_models.IndustryCompanyResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetIndustryCompaniesUnauthorized creates a GetIndustryCompaniesUnauthorized with default headers values
func NewGetIndustryCompaniesUnauthorized() *GetIndustryCompaniesUnauthorized {
	return &GetIndustryCompaniesUnauthorized{}
}

/*
GetIndustryCompaniesUnauthorized describes a response with status code 401, with default header values.

Access unauthorized, invalid API-KEY was used
*/
type GetIndustryCompaniesUnauthorized struct {
	Payload *sfgate_models.Error
}

// IsSuccess returns true when this get industry companies unauthorized response has a 2xx status code
func (o *GetIndustryCompaniesUnauthorized) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this get industry companies unauthorized response has a 3xx status code
func (o *GetIndustryCompaniesUnauthorized) IsRedirect() bool {
	return false
}

// IsClientError returns true when this get industry companies unauthorized response has a 4xx status code
func (o *GetIndustryCompaniesUnauthorized) IsClientError() bool {
	return true
}

// IsServerError returns true when this get industry companies unauthorized response has a 5xx status code
func (o *GetIndustryCompaniesUnauthorized) IsServerError() bool {
	return false
}

// IsCode returns true when this get industry companies unauthorized response a status code equal to that given
func (o *GetIndustryCompaniesUnauthorized) IsCode(code int) bool {
	return code == 401
}

// Code gets the status code for the get industry companies unauthorized response
func (o *GetIndustryCompaniesUnauthorized) Code() int {
	return 401
}

func (o *GetIndustryCompaniesUnauthorized) Error() string {
	return fmt.Sprintf("[GET /industrycompanies][%d] getIndustryCompaniesUnauthorized  %+v", 401, o.Payload)
}

func (o *GetIndustryCompaniesUnauthorized) String() string {
	return fmt.Sprintf("[GET /industrycompanies][%d] getIndustryCompaniesUnauthorized  %+v", 401, o.Payload)
}

func (o *GetIndustryCompaniesUnauthorized) GetPayload() *sfgate_models.Error {
	return o.Payload
}

func (o *GetIndustryCompaniesUnauthorized) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(sfgate_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetIndustryCompaniesForbidden creates a GetIndustryCompaniesForbidden with default headers values
func NewGetIndustryCompaniesForbidden() *GetIndustryCompaniesForbidden {
	return &GetIndustryCompaniesForbidden{}
}

/*
GetIndustryCompaniesForbidden describes a response with status code 403, with default header values.

Access forbidden, account lacks access
*/
type GetIndustryCompaniesForbidden struct {
	Payload *sfgate_models.Error
}

// IsSuccess returns true when this get industry companies forbidden response has a 2xx status code
func (o *GetIndustryCompaniesForbidden) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this get industry companies forbidden response has a 3xx status code
func (o *GetIndustryCompaniesForbidden) IsRedirect() bool {
	return false
}

// IsClientError returns true when this get industry companies forbidden response has a 4xx status code
func (o *GetIndustryCompaniesForbidden) IsClientError() bool {
	return true
}

// IsServerError returns true when this get industry companies forbidden response has a 5xx status code
func (o *GetIndustryCompaniesForbidden) IsServerError() bool {
	return false
}

// IsCode returns true when this get industry companies forbidden response a status code equal to that given
func (o *GetIndustryCompaniesForbidden) IsCode(code int) bool {
	return code == 403
}

// Code gets the status code for the get industry companies forbidden response
func (o *GetIndustryCompaniesForbidden) Code() int {
	return 403
}

func (o *GetIndustryCompaniesForbidden) Error() string {
	return fmt.Sprintf("[GET /industrycompanies][%d] getIndustryCompaniesForbidden  %+v", 403, o.Payload)
}

func (o *GetIndustryCompaniesForbidden) String() string {
	return fmt.Sprintf("[GET /industrycompanies][%d] getIndustryCompaniesForbidden  %+v", 403, o.Payload)
}

func (o *GetIndustryCompaniesForbidden) GetPayload() *sfgate_models.Error {
	return o.Payload
}

func (o *GetIndustryCompaniesForbidden) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(sfgate_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetIndustryCompaniesNotFound creates a GetIndustryCompaniesNotFound with default headers values
func NewGetIndustryCompaniesNotFound() *GetIndustryCompaniesNotFound {
	return &GetIndustryCompaniesNotFound{}
}

/*
GetIndustryCompaniesNotFound describes a response with status code 404, with default header values.

Resource was not found
*/
type GetIndustryCompaniesNotFound struct {
	Payload *sfgate_models.Error
}

// IsSuccess returns true when this get industry companies not found response has a 2xx status code
func (o *GetIndustryCompaniesNotFound) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this get industry companies not found response has a 3xx status code
func (o *GetIndustryCompaniesNotFound) IsRedirect() bool {
	return false
}

// IsClientError returns true when this get industry companies not found response has a 4xx status code
func (o *GetIndustryCompaniesNotFound) IsClientError() bool {
	return true
}

// IsServerError returns true when this get industry companies not found response has a 5xx status code
func (o *GetIndustryCompaniesNotFound) IsServerError() bool {
	return false
}

// IsCode returns true when this get industry companies not found response a status code equal to that given
func (o *GetIndustryCompaniesNotFound) IsCode(code int) bool {
	return code == 404
}

// Code gets the status code for the get industry companies not found response
func (o *GetIndustryCompaniesNotFound) Code() int {
	return 404
}

func (o *GetIndustryCompaniesNotFound) Error() string {
	return fmt.Sprintf("[GET /industrycompanies][%d] getIndustryCompaniesNotFound  %+v", 404, o.Payload)
}

func (o *GetIndustryCompaniesNotFound) String() string {
	return fmt.Sprintf("[GET /industrycompanies][%d] getIndustryCompaniesNotFound  %+v", 404, o.Payload)
}

func (o *GetIndustryCompaniesNotFound) GetPayload() *sfgate_models.Error {
	return o.Payload
}

func (o *GetIndustryCompaniesNotFound) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(sfgate_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetIndustryCompaniesUnprocessableEntity creates a GetIndustryCompaniesUnprocessableEntity with default headers values
func NewGetIndustryCompaniesUnprocessableEntity() *GetIndustryCompaniesUnprocessableEntity {
	return &GetIndustryCompaniesUnprocessableEntity{}
}

/*
GetIndustryCompaniesUnprocessableEntity describes a response with status code 422, with default header values.

Unprocessable Entity, likely a bad parameter
*/
type GetIndustryCompaniesUnprocessableEntity struct {
	Payload *sfgate_models.Error
}

// IsSuccess returns true when this get industry companies unprocessable entity response has a 2xx status code
func (o *GetIndustryCompaniesUnprocessableEntity) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this get industry companies unprocessable entity response has a 3xx status code
func (o *GetIndustryCompaniesUnprocessableEntity) IsRedirect() bool {
	return false
}

// IsClientError returns true when this get industry companies unprocessable entity response has a 4xx status code
func (o *GetIndustryCompaniesUnprocessableEntity) IsClientError() bool {
	return true
}

// IsServerError returns true when this get industry companies unprocessable entity response has a 5xx status code
func (o *GetIndustryCompaniesUnprocessableEntity) IsServerError() bool {
	return false
}

// IsCode returns true when this get industry companies unprocessable entity response a status code equal to that given
func (o *GetIndustryCompaniesUnprocessableEntity) IsCode(code int) bool {
	return code == 422
}

// Code gets the status code for the get industry companies unprocessable entity response
func (o *GetIndustryCompaniesUnprocessableEntity) Code() int {
	return 422
}

func (o *GetIndustryCompaniesUnprocessableEntity) Error() string {
	return fmt.Sprintf("[GET /industrycompanies][%d] getIndustryCompaniesUnprocessableEntity  %+v", 422, o.Payload)
}

func (o *GetIndustryCompaniesUnprocessableEntity) String() string {
	return fmt.Sprintf("[GET /industrycompanies][%d] getIndustryCompaniesUnprocessableEntity  %+v", 422, o.Payload)
}

func (o *GetIndustryCompaniesUnprocessableEntity) GetPayload() *sfgate_models.Error {
	return o.Payload
}

func (o *GetIndustryCompaniesUnprocessableEntity) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(sfgate_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetIndustryCompaniesInternalServerError creates a GetIndustryCompaniesInternalServerError with default headers values
func NewGetIndustryCompaniesInternalServerError() *GetIndustryCompaniesInternalServerError {
	return &GetIndustryCompaniesInternalServerError{}
}

/*
GetIndustryCompaniesInternalServerError describes a response with status code 500, with default header values.

Server Internal Error
*/
type GetIndustryCompaniesInternalServerError struct {
	Payload *sfgate_models.Error
}

// IsSuccess returns true when this get industry companies internal server error response has a 2xx status code
func (o *GetIndustryCompaniesInternalServerError) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this get industry companies internal server error response has a 3xx status code
func (o *GetIndustryCompaniesInternalServerError) IsRedirect() bool {
	return false
}

// IsClientError returns true when this get industry companies internal server error response has a 4xx status code
func (o *GetIndustryCompaniesInternalServerError) IsClientError() bool {
	return false
}

// IsServerError returns true when this get industry companies internal server error response has a 5xx status code
func (o *GetIndustryCompaniesInternalServerError) IsServerError() bool {
	return true
}

// IsCode returns true when this get industry companies internal server error response a status code equal to that given
func (o *GetIndustryCompaniesInternalServerError) IsCode(code int) bool {
	return code == 500
}

// Code gets the status code for the get industry companies internal server error response
func (o *GetIndustryCompaniesInternalServerError) Code() int {
	return 500
}

func (o *GetIndustryCompaniesInternalServerError) Error() string {
	return fmt.Sprintf("[GET /industrycompanies][%d] getIndustryCompaniesInternalServerError  %+v", 500, o.Payload)
}

func (o *GetIndustryCompaniesInternalServerError) String() string {
	return fmt.Sprintf("[GET /industrycompanies][%d] getIndustryCompaniesInternalServerError  %+v", 500, o.Payload)
}

func (o *GetIndustryCompaniesInternalServerError) GetPayload() *sfgate_models.Error {
	return o.Payload
}

func (o *GetIndustryCompaniesInternalServerError) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(sfgate_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
