// Code generated by go-swagger; DO NOT EDIT.

// (c) 2012-2023 by Vernon Keenan
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package industry_products

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"
)

// New creates a new industry products API client.
func New(transport runtime.ClientTransport, formats strfmt.Registry) ClientService {
	return &Client{transport: transport, formats: formats}
}

/*
Client for industry products API
*/
type Client struct {
	transport runtime.ClientTransport
	formats   strfmt.Registry
}

// ClientOption is the option for Client methods
type ClientOption func(*runtime.ClientOperation)

// ClientService is the interface for Client methods
type ClientService interface {
	GetIndustryProducts(params *GetIndustryProductsParams, authInfo runtime.ClientAuthInfoWriter, opts ...ClientOption) (*GetIndustryProductsOK, error)

	PostIndustryproducts(params *PostIndustryproductsParams, authInfo runtime.ClientAuthInfoWriter, opts ...ClientOption) (*PostIndustryproductsCreated, error)

	SetTransport(transport runtime.ClientTransport)
}

/*
GetIndustryProducts gets a list of industry products

Return a list of all available IndustryProducts
*/
func (a *Client) GetIndustryProducts(params *GetIndustryProductsParams, authInfo runtime.ClientAuthInfoWriter, opts ...ClientOption) (*GetIndustryProductsOK, error) {
	// TODO: Validate the params before sending
	if params == nil {
		params = NewGetIndustryProductsParams()
	}
	op := &runtime.ClientOperation{
		ID:                 "getIndustryProducts",
		Method:             "GET",
		PathPattern:        "/industryproducts",
		ProducesMediaTypes: []string{"application/json"},
		ConsumesMediaTypes: []string{"application/json"},
		Schemes:            []string{"http"},
		Params:             params,
		Reader:             &GetIndustryProductsReader{formats: a.formats},
		AuthInfo:           authInfo,
		Context:            params.Context,
		Client:             params.HTTPClient,
	}
	for _, opt := range opts {
		opt(op)
	}

	result, err := a.transport.Submit(op)
	if err != nil {
		return nil, err
	}
	success, ok := result.(*GetIndustryProductsOK)
	if ok {
		return success, nil
	}
	// unexpected success response
	// safeguard: normally, absent a default response, unknown success responses return an error above: so this is a codegen issue
	msg := fmt.Sprintf("unexpected success response for getIndustryProducts: API contract not enforced by server. Client expected to get an error, but got: %T", result)
	panic(msg)
}

/*
PostIndustryproducts adds a new industryproduct

Industry record to be added
*/
func (a *Client) PostIndustryproducts(params *PostIndustryproductsParams, authInfo runtime.ClientAuthInfoWriter, opts ...ClientOption) (*PostIndustryproductsCreated, error) {
	// TODO: Validate the params before sending
	if params == nil {
		params = NewPostIndustryproductsParams()
	}
	op := &runtime.ClientOperation{
		ID:                 "postIndustryproducts",
		Method:             "POST",
		PathPattern:        "/industryproducts",
		ProducesMediaTypes: []string{"application/json"},
		ConsumesMediaTypes: []string{"application/json"},
		Schemes:            []string{"http"},
		Params:             params,
		Reader:             &PostIndustryproductsReader{formats: a.formats},
		AuthInfo:           authInfo,
		Context:            params.Context,
		Client:             params.HTTPClient,
	}
	for _, opt := range opts {
		opt(op)
	}

	result, err := a.transport.Submit(op)
	if err != nil {
		return nil, err
	}
	success, ok := result.(*PostIndustryproductsCreated)
	if ok {
		return success, nil
	}
	// unexpected success response
	// safeguard: normally, absent a default response, unknown success responses return an error above: so this is a codegen issue
	msg := fmt.Sprintf("unexpected success response for postIndustryproducts: API contract not enforced by server. Client expected to get an error, but got: %T", result)
	panic(msg)
}

// SetTransport changes the transport on the client
func (a *Client) SetTransport(transport runtime.ClientTransport) {
	a.transport = transport
}
