// Code generated by go-swagger; DO NOT EDIT.

// (c) 2012-2023 by Vernon Keenan
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package industry_services

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"
)

// New creates a new industry services API client.
func New(transport runtime.ClientTransport, formats strfmt.Registry) ClientService {
	return &Client{transport: transport, formats: formats}
}

/*
Client for industry services API
*/
type Client struct {
	transport runtime.ClientTransport
	formats   strfmt.Registry
}

// ClientOption is the option for Client methods
type ClientOption func(*runtime.ClientOperation)

// ClientService is the interface for Client methods
type ClientService interface {
	GetIndustryServices(params *GetIndustryServicesParams, authInfo runtime.ClientAuthInfoWriter, opts ...ClientOption) (*GetIndustryServicesOK, error)

	PostIndustryServices(params *PostIndustryServicesParams, authInfo runtime.ClientAuthInfoWriter, opts ...ClientOption) (*PostIndustryServicesCreated, error)

	SetTransport(transport runtime.ClientTransport)
}

/*
GetIndustryServices gets a list of industry services

Return a list of all available IndustryServices
*/
func (a *Client) GetIndustryServices(params *GetIndustryServicesParams, authInfo runtime.ClientAuthInfoWriter, opts ...ClientOption) (*GetIndustryServicesOK, error) {
	// TODO: Validate the params before sending
	if params == nil {
		params = NewGetIndustryServicesParams()
	}
	op := &runtime.ClientOperation{
		ID:                 "getIndustryServices",
		Method:             "GET",
		PathPattern:        "/industryservices",
		ProducesMediaTypes: []string{"application/json"},
		ConsumesMediaTypes: []string{"application/json"},
		Schemes:            []string{"http"},
		Params:             params,
		Reader:             &GetIndustryServicesReader{formats: a.formats},
		AuthInfo:           authInfo,
		Context:            params.Context,
		Client:             params.HTTPClient,
	}
	for _, opt := range opts {
		opt(op)
	}

	result, err := a.transport.Submit(op)
	if err != nil {
		return nil, err
	}
	success, ok := result.(*GetIndustryServicesOK)
	if ok {
		return success, nil
	}
	// unexpected success response
	// safeguard: normally, absent a default response, unknown success responses return an error above: so this is a codegen issue
	msg := fmt.Sprintf("unexpected success response for getIndustryServices: API contract not enforced by server. Client expected to get an error, but got: %T", result)
	panic(msg)
}

/*
PostIndustryServices adds a new industry service

IndustryService record to be added
*/
func (a *Client) PostIndustryServices(params *PostIndustryServicesParams, authInfo runtime.ClientAuthInfoWriter, opts ...ClientOption) (*PostIndustryServicesCreated, error) {
	// TODO: Validate the params before sending
	if params == nil {
		params = NewPostIndustryServicesParams()
	}
	op := &runtime.ClientOperation{
		ID:                 "postIndustryServices",
		Method:             "POST",
		PathPattern:        "/industryservices",
		ProducesMediaTypes: []string{"application/json"},
		ConsumesMediaTypes: []string{"application/json"},
		Schemes:            []string{"http"},
		Params:             params,
		Reader:             &PostIndustryServicesReader{formats: a.formats},
		AuthInfo:           authInfo,
		Context:            params.Context,
		Client:             params.HTTPClient,
	}
	for _, opt := range opts {
		opt(op)
	}

	result, err := a.transport.Submit(op)
	if err != nil {
		return nil, err
	}
	success, ok := result.(*PostIndustryServicesCreated)
	if ok {
		return success, nil
	}
	// unexpected success response
	// safeguard: normally, absent a default response, unknown success responses return an error above: so this is a codegen issue
	msg := fmt.Sprintf("unexpected success response for postIndustryServices: API contract not enforced by server. Client expected to get an error, but got: %T", result)
	panic(msg)
}

// SetTransport changes the transport on the client
func (a *Client) SetTransport(transport runtime.ClientTransport) {
	a.transport = transport
}
