// Code generated by go-swagger; DO NOT EDIT.

// (c) 2012-2023 by Vernon Keenan
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package observations

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"
)

// New creates a new observations API client.
func New(transport runtime.ClientTransport, formats strfmt.Registry) ClientService {
	return &Client{transport: transport, formats: formats}
}

/*
Client for observations API
*/
type Client struct {
	transport runtime.ClientTransport
	formats   strfmt.Registry
}

// ClientOption is the option for Client methods
type ClientOption func(*runtime.ClientOperation)

// ClientService is the interface for Client methods
type ClientService interface {
	GetObservations(params *GetObservationsParams, authInfo runtime.ClientAuthInfoWriter, opts ...ClientOption) (*GetObservationsOK, error)

	PostObservations(params *PostObservationsParams, authInfo runtime.ClientAuthInfoWriter, opts ...ClientOption) (*PostObservationsCreated, error)

	SetTransport(transport runtime.ClientTransport)
}

/*
GetObservations gets a list of observations

Return a list of all available Observations
*/
func (a *Client) GetObservations(params *GetObservationsParams, authInfo runtime.ClientAuthInfoWriter, opts ...ClientOption) (*GetObservationsOK, error) {
	// TODO: Validate the params before sending
	if params == nil {
		params = NewGetObservationsParams()
	}
	op := &runtime.ClientOperation{
		ID:                 "getObservations",
		Method:             "GET",
		PathPattern:        "/observations",
		ProducesMediaTypes: []string{"application/json"},
		ConsumesMediaTypes: []string{"application/json"},
		Schemes:            []string{"http"},
		Params:             params,
		Reader:             &GetObservationsReader{formats: a.formats},
		AuthInfo:           authInfo,
		Context:            params.Context,
		Client:             params.HTTPClient,
	}
	for _, opt := range opts {
		opt(op)
	}

	result, err := a.transport.Submit(op)
	if err != nil {
		return nil, err
	}
	success, ok := result.(*GetObservationsOK)
	if ok {
		return success, nil
	}
	// unexpected success response
	// safeguard: normally, absent a default response, unknown success responses return an error above: so this is a codegen issue
	msg := fmt.Sprintf("unexpected success response for getObservations: API contract not enforced by server. Client expected to get an error, but got: %T", result)
	panic(msg)
}

/*
PostObservations adds a new observation

Observation record to be added
*/
func (a *Client) PostObservations(params *PostObservationsParams, authInfo runtime.ClientAuthInfoWriter, opts ...ClientOption) (*PostObservationsCreated, error) {
	// TODO: Validate the params before sending
	if params == nil {
		params = NewPostObservationsParams()
	}
	op := &runtime.ClientOperation{
		ID:                 "postObservations",
		Method:             "POST",
		PathPattern:        "/observations",
		ProducesMediaTypes: []string{"application/json"},
		ConsumesMediaTypes: []string{"application/json"},
		Schemes:            []string{"http"},
		Params:             params,
		Reader:             &PostObservationsReader{formats: a.formats},
		AuthInfo:           authInfo,
		Context:            params.Context,
		Client:             params.HTTPClient,
	}
	for _, opt := range opts {
		opt(op)
	}

	result, err := a.transport.Submit(op)
	if err != nil {
		return nil, err
	}
	success, ok := result.(*PostObservationsCreated)
	if ok {
		return success, nil
	}
	// unexpected success response
	// safeguard: normally, absent a default response, unknown success responses return an error above: so this is a codegen issue
	msg := fmt.Sprintf("unexpected success response for postObservations: API contract not enforced by server. Client expected to get an error, but got: %T", result)
	panic(msg)
}

// SetTransport changes the transport on the client
func (a *Client) SetTransport(transport runtime.ClientTransport) {
	a.transport = transport
}
