// Code generated by go-swagger; DO NOT EDIT.

// (c) 2012-2023 by Vernon Keenan
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package prompts

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"

	"code.tnxs.net/work/lib/api/sfgate/sfgate_models"
)

// NewPutPromptTagsParams creates a new PutPromptTagsParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewPutPromptTagsParams() *PutPromptTagsParams {
	return &PutPromptTagsParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewPutPromptTagsParamsWithTimeout creates a new PutPromptTagsParams object
// with the ability to set a timeout on a request.
func NewPutPromptTagsParamsWithTimeout(timeout time.Duration) *PutPromptTagsParams {
	return &PutPromptTagsParams{
		timeout: timeout,
	}
}

// NewPutPromptTagsParamsWithContext creates a new PutPromptTagsParams object
// with the ability to set a context for a request.
func NewPutPromptTagsParamsWithContext(ctx context.Context) *PutPromptTagsParams {
	return &PutPromptTagsParams{
		Context: ctx,
	}
}

// NewPutPromptTagsParamsWithHTTPClient creates a new PutPromptTagsParams object
// with the ability to set a custom HTTPClient for a request.
func NewPutPromptTagsParamsWithHTTPClient(client *http.Client) *PutPromptTagsParams {
	return &PutPromptTagsParams{
		HTTPClient: client,
	}
}

/*
PutPromptTagsParams contains all the parameters to send to the API endpoint

	for the put prompt tags operation.

	Typically these are written to a http.Request.
*/
type PutPromptTagsParams struct {

	/* PromptTagRequest.

	   An array of PromptTag objects
	*/
	PromptTagRequest *sfgate_models.PromptTagRequest

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the put prompt tags params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *PutPromptTagsParams) WithDefaults() *PutPromptTagsParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the put prompt tags params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *PutPromptTagsParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the put prompt tags params
func (o *PutPromptTagsParams) WithTimeout(timeout time.Duration) *PutPromptTagsParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the put prompt tags params
func (o *PutPromptTagsParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the put prompt tags params
func (o *PutPromptTagsParams) WithContext(ctx context.Context) *PutPromptTagsParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the put prompt tags params
func (o *PutPromptTagsParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the put prompt tags params
func (o *PutPromptTagsParams) WithHTTPClient(client *http.Client) *PutPromptTagsParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the put prompt tags params
func (o *PutPromptTagsParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithPromptTagRequest adds the promptTagRequest to the put prompt tags params
func (o *PutPromptTagsParams) WithPromptTagRequest(promptTagRequest *sfgate_models.PromptTagRequest) *PutPromptTagsParams {
	o.SetPromptTagRequest(promptTagRequest)
	return o
}

// SetPromptTagRequest adds the promptTagRequest to the put prompt tags params
func (o *PutPromptTagsParams) SetPromptTagRequest(promptTagRequest *sfgate_models.PromptTagRequest) {
	o.PromptTagRequest = promptTagRequest
}

// WriteToRequest writes these params to a swagger request
func (o *PutPromptTagsParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error
	if o.PromptTagRequest != nil {
		if err := r.SetBodyParam(o.PromptTagRequest); err != nil {
			return err
		}
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
