// Code generated by go-swagger; DO NOT EDIT.

// (c) 2012-2023 by Vernon Keenan
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package research_projects

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"

	"code.tnxs.net/work/lib/api/sfgate/sfgate_models"
)

// NewPostResearchProjectsParams creates a new PostResearchProjectsParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewPostResearchProjectsParams() *PostResearchProjectsParams {
	return &PostResearchProjectsParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewPostResearchProjectsParamsWithTimeout creates a new PostResearchProjectsParams object
// with the ability to set a timeout on a request.
func NewPostResearchProjectsParamsWithTimeout(timeout time.Duration) *PostResearchProjectsParams {
	return &PostResearchProjectsParams{
		timeout: timeout,
	}
}

// NewPostResearchProjectsParamsWithContext creates a new PostResearchProjectsParams object
// with the ability to set a context for a request.
func NewPostResearchProjectsParamsWithContext(ctx context.Context) *PostResearchProjectsParams {
	return &PostResearchProjectsParams{
		Context: ctx,
	}
}

// NewPostResearchProjectsParamsWithHTTPClient creates a new PostResearchProjectsParams object
// with the ability to set a custom HTTPClient for a request.
func NewPostResearchProjectsParamsWithHTTPClient(client *http.Client) *PostResearchProjectsParams {
	return &PostResearchProjectsParams{
		HTTPClient: client,
	}
}

/*
PostResearchProjectsParams contains all the parameters to send to the API endpoint

	for the post research projects operation.

	Typically these are written to a http.Request.
*/
type PostResearchProjectsParams struct {

	/* ResearchProjectRequest.

	   An array of new ResearchProject records
	*/
	ResearchProjectRequest *sfgate_models.ResearchProjectRequest

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the post research projects params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *PostResearchProjectsParams) WithDefaults() *PostResearchProjectsParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the post research projects params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *PostResearchProjectsParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the post research projects params
func (o *PostResearchProjectsParams) WithTimeout(timeout time.Duration) *PostResearchProjectsParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the post research projects params
func (o *PostResearchProjectsParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the post research projects params
func (o *PostResearchProjectsParams) WithContext(ctx context.Context) *PostResearchProjectsParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the post research projects params
func (o *PostResearchProjectsParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the post research projects params
func (o *PostResearchProjectsParams) WithHTTPClient(client *http.Client) *PostResearchProjectsParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the post research projects params
func (o *PostResearchProjectsParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithResearchProjectRequest adds the researchProjectRequest to the post research projects params
func (o *PostResearchProjectsParams) WithResearchProjectRequest(researchProjectRequest *sfgate_models.ResearchProjectRequest) *PostResearchProjectsParams {
	o.SetResearchProjectRequest(researchProjectRequest)
	return o
}

// SetResearchProjectRequest adds the researchProjectRequest to the post research projects params
func (o *PostResearchProjectsParams) SetResearchProjectRequest(researchProjectRequest *sfgate_models.ResearchProjectRequest) {
	o.ResearchProjectRequest = researchProjectRequest
}

// WriteToRequest writes these params to a swagger request
func (o *PostResearchProjectsParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error
	if o.ResearchProjectRequest != nil {
		if err := r.SetBodyParam(o.ResearchProjectRequest); err != nil {
			return err
		}
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
