// Code generated by go-swagger; DO NOT EDIT.

// (c) 2012-2023 by Vernon Keenan
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package tenants

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"

	"code.tnxs.net/work/lib/api/sfgate/sfgate_models"
)

// GetTenantsReader is a Reader for the GetTenants structure.
type GetTenantsReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *GetTenantsReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewGetTenantsOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 401:
		result := NewGetTenantsUnauthorized()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 403:
		result := NewGetTenantsForbidden()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 404:
		result := NewGetTenantsNotFound()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 422:
		result := NewGetTenantsUnprocessableEntity()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 500:
		result := NewGetTenantsInternalServerError()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		return nil, runtime.NewAPIError("response status code does not match any response statuses defined for this endpoint in the swagger spec", response, response.Code())
	}
}

// NewGetTenantsOK creates a GetTenantsOK with default headers values
func NewGetTenantsOK() *GetTenantsOK {
	return &GetTenantsOK{}
}

/*
GetTenantsOK describes a response with status code 200, with default header values.

Response with Tenant objects
*/
type GetTenantsOK struct {
	Payload *sfgate_models.TenantResponse
}

// IsSuccess returns true when this get tenants o k response has a 2xx status code
func (o *GetTenantsOK) IsSuccess() bool {
	return true
}

// IsRedirect returns true when this get tenants o k response has a 3xx status code
func (o *GetTenantsOK) IsRedirect() bool {
	return false
}

// IsClientError returns true when this get tenants o k response has a 4xx status code
func (o *GetTenantsOK) IsClientError() bool {
	return false
}

// IsServerError returns true when this get tenants o k response has a 5xx status code
func (o *GetTenantsOK) IsServerError() bool {
	return false
}

// IsCode returns true when this get tenants o k response a status code equal to that given
func (o *GetTenantsOK) IsCode(code int) bool {
	return code == 200
}

// Code gets the status code for the get tenants o k response
func (o *GetTenantsOK) Code() int {
	return 200
}

func (o *GetTenantsOK) Error() string {
	return fmt.Sprintf("[GET /tenants][%d] getTenantsOK  %+v", 200, o.Payload)
}

func (o *GetTenantsOK) String() string {
	return fmt.Sprintf("[GET /tenants][%d] getTenantsOK  %+v", 200, o.Payload)
}

func (o *GetTenantsOK) GetPayload() *sfgate_models.TenantResponse {
	return o.Payload
}

func (o *GetTenantsOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(sfgate_models.TenantResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetTenantsUnauthorized creates a GetTenantsUnauthorized with default headers values
func NewGetTenantsUnauthorized() *GetTenantsUnauthorized {
	return &GetTenantsUnauthorized{}
}

/*
GetTenantsUnauthorized describes a response with status code 401, with default header values.

Access unauthorized, invalid API-KEY was used
*/
type GetTenantsUnauthorized struct {
	Payload *sfgate_models.Error
}

// IsSuccess returns true when this get tenants unauthorized response has a 2xx status code
func (o *GetTenantsUnauthorized) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this get tenants unauthorized response has a 3xx status code
func (o *GetTenantsUnauthorized) IsRedirect() bool {
	return false
}

// IsClientError returns true when this get tenants unauthorized response has a 4xx status code
func (o *GetTenantsUnauthorized) IsClientError() bool {
	return true
}

// IsServerError returns true when this get tenants unauthorized response has a 5xx status code
func (o *GetTenantsUnauthorized) IsServerError() bool {
	return false
}

// IsCode returns true when this get tenants unauthorized response a status code equal to that given
func (o *GetTenantsUnauthorized) IsCode(code int) bool {
	return code == 401
}

// Code gets the status code for the get tenants unauthorized response
func (o *GetTenantsUnauthorized) Code() int {
	return 401
}

func (o *GetTenantsUnauthorized) Error() string {
	return fmt.Sprintf("[GET /tenants][%d] getTenantsUnauthorized  %+v", 401, o.Payload)
}

func (o *GetTenantsUnauthorized) String() string {
	return fmt.Sprintf("[GET /tenants][%d] getTenantsUnauthorized  %+v", 401, o.Payload)
}

func (o *GetTenantsUnauthorized) GetPayload() *sfgate_models.Error {
	return o.Payload
}

func (o *GetTenantsUnauthorized) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(sfgate_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetTenantsForbidden creates a GetTenantsForbidden with default headers values
func NewGetTenantsForbidden() *GetTenantsForbidden {
	return &GetTenantsForbidden{}
}

/*
GetTenantsForbidden describes a response with status code 403, with default header values.

Access forbidden, account lacks access
*/
type GetTenantsForbidden struct {
	Payload *sfgate_models.Error
}

// IsSuccess returns true when this get tenants forbidden response has a 2xx status code
func (o *GetTenantsForbidden) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this get tenants forbidden response has a 3xx status code
func (o *GetTenantsForbidden) IsRedirect() bool {
	return false
}

// IsClientError returns true when this get tenants forbidden response has a 4xx status code
func (o *GetTenantsForbidden) IsClientError() bool {
	return true
}

// IsServerError returns true when this get tenants forbidden response has a 5xx status code
func (o *GetTenantsForbidden) IsServerError() bool {
	return false
}

// IsCode returns true when this get tenants forbidden response a status code equal to that given
func (o *GetTenantsForbidden) IsCode(code int) bool {
	return code == 403
}

// Code gets the status code for the get tenants forbidden response
func (o *GetTenantsForbidden) Code() int {
	return 403
}

func (o *GetTenantsForbidden) Error() string {
	return fmt.Sprintf("[GET /tenants][%d] getTenantsForbidden  %+v", 403, o.Payload)
}

func (o *GetTenantsForbidden) String() string {
	return fmt.Sprintf("[GET /tenants][%d] getTenantsForbidden  %+v", 403, o.Payload)
}

func (o *GetTenantsForbidden) GetPayload() *sfgate_models.Error {
	return o.Payload
}

func (o *GetTenantsForbidden) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(sfgate_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetTenantsNotFound creates a GetTenantsNotFound with default headers values
func NewGetTenantsNotFound() *GetTenantsNotFound {
	return &GetTenantsNotFound{}
}

/*
GetTenantsNotFound describes a response with status code 404, with default header values.

Resource was not found
*/
type GetTenantsNotFound struct {
	Payload *sfgate_models.Error
}

// IsSuccess returns true when this get tenants not found response has a 2xx status code
func (o *GetTenantsNotFound) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this get tenants not found response has a 3xx status code
func (o *GetTenantsNotFound) IsRedirect() bool {
	return false
}

// IsClientError returns true when this get tenants not found response has a 4xx status code
func (o *GetTenantsNotFound) IsClientError() bool {
	return true
}

// IsServerError returns true when this get tenants not found response has a 5xx status code
func (o *GetTenantsNotFound) IsServerError() bool {
	return false
}

// IsCode returns true when this get tenants not found response a status code equal to that given
func (o *GetTenantsNotFound) IsCode(code int) bool {
	return code == 404
}

// Code gets the status code for the get tenants not found response
func (o *GetTenantsNotFound) Code() int {
	return 404
}

func (o *GetTenantsNotFound) Error() string {
	return fmt.Sprintf("[GET /tenants][%d] getTenantsNotFound  %+v", 404, o.Payload)
}

func (o *GetTenantsNotFound) String() string {
	return fmt.Sprintf("[GET /tenants][%d] getTenantsNotFound  %+v", 404, o.Payload)
}

func (o *GetTenantsNotFound) GetPayload() *sfgate_models.Error {
	return o.Payload
}

func (o *GetTenantsNotFound) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(sfgate_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetTenantsUnprocessableEntity creates a GetTenantsUnprocessableEntity with default headers values
func NewGetTenantsUnprocessableEntity() *GetTenantsUnprocessableEntity {
	return &GetTenantsUnprocessableEntity{}
}

/*
GetTenantsUnprocessableEntity describes a response with status code 422, with default header values.

Unprocessable Entity, likely a bad parameter
*/
type GetTenantsUnprocessableEntity struct {
	Payload *sfgate_models.Error
}

// IsSuccess returns true when this get tenants unprocessable entity response has a 2xx status code
func (o *GetTenantsUnprocessableEntity) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this get tenants unprocessable entity response has a 3xx status code
func (o *GetTenantsUnprocessableEntity) IsRedirect() bool {
	return false
}

// IsClientError returns true when this get tenants unprocessable entity response has a 4xx status code
func (o *GetTenantsUnprocessableEntity) IsClientError() bool {
	return true
}

// IsServerError returns true when this get tenants unprocessable entity response has a 5xx status code
func (o *GetTenantsUnprocessableEntity) IsServerError() bool {
	return false
}

// IsCode returns true when this get tenants unprocessable entity response a status code equal to that given
func (o *GetTenantsUnprocessableEntity) IsCode(code int) bool {
	return code == 422
}

// Code gets the status code for the get tenants unprocessable entity response
func (o *GetTenantsUnprocessableEntity) Code() int {
	return 422
}

func (o *GetTenantsUnprocessableEntity) Error() string {
	return fmt.Sprintf("[GET /tenants][%d] getTenantsUnprocessableEntity  %+v", 422, o.Payload)
}

func (o *GetTenantsUnprocessableEntity) String() string {
	return fmt.Sprintf("[GET /tenants][%d] getTenantsUnprocessableEntity  %+v", 422, o.Payload)
}

func (o *GetTenantsUnprocessableEntity) GetPayload() *sfgate_models.Error {
	return o.Payload
}

func (o *GetTenantsUnprocessableEntity) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(sfgate_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetTenantsInternalServerError creates a GetTenantsInternalServerError with default headers values
func NewGetTenantsInternalServerError() *GetTenantsInternalServerError {
	return &GetTenantsInternalServerError{}
}

/*
GetTenantsInternalServerError describes a response with status code 500, with default header values.

Server Internal Error
*/
type GetTenantsInternalServerError struct {
	Payload *sfgate_models.Error
}

// IsSuccess returns true when this get tenants internal server error response has a 2xx status code
func (o *GetTenantsInternalServerError) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this get tenants internal server error response has a 3xx status code
func (o *GetTenantsInternalServerError) IsRedirect() bool {
	return false
}

// IsClientError returns true when this get tenants internal server error response has a 4xx status code
func (o *GetTenantsInternalServerError) IsClientError() bool {
	return false
}

// IsServerError returns true when this get tenants internal server error response has a 5xx status code
func (o *GetTenantsInternalServerError) IsServerError() bool {
	return true
}

// IsCode returns true when this get tenants internal server error response a status code equal to that given
func (o *GetTenantsInternalServerError) IsCode(code int) bool {
	return code == 500
}

// Code gets the status code for the get tenants internal server error response
func (o *GetTenantsInternalServerError) Code() int {
	return 500
}

func (o *GetTenantsInternalServerError) Error() string {
	return fmt.Sprintf("[GET /tenants][%d] getTenantsInternalServerError  %+v", 500, o.Payload)
}

func (o *GetTenantsInternalServerError) String() string {
	return fmt.Sprintf("[GET /tenants][%d] getTenantsInternalServerError  %+v", 500, o.Payload)
}

func (o *GetTenantsInternalServerError) GetPayload() *sfgate_models.Error {
	return o.Payload
}

func (o *GetTenantsInternalServerError) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(sfgate_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
