// Code generated by go-swagger; DO NOT EDIT.

// (c) 2012-2023 by Vernon Keenan
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package tenants

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"

	"code.tnxs.net/work/lib/api/sfgate/sfgate_models"
)

// TenantsReader is a Reader for the Tenants structure.
type TenantsReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *TenantsReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 201:
		result := NewTenantsCreated()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 401:
		result := NewTenantsUnauthorized()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 403:
		result := NewTenantsForbidden()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 404:
		result := NewTenantsNotFound()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 422:
		result := NewTenantsUnprocessableEntity()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 500:
		result := NewTenantsInternalServerError()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		return nil, runtime.NewAPIError("response status code does not match any response statuses defined for this endpoint in the swagger spec", response, response.Code())
	}
}

// NewTenantsCreated creates a TenantsCreated with default headers values
func NewTenantsCreated() *TenantsCreated {
	return &TenantsCreated{}
}

/*
TenantsCreated describes a response with status code 201, with default header values.

Response from Salesforce
*/
type TenantsCreated struct {
	Payload *sfgate_models.SalesforcePostResponse
}

// IsSuccess returns true when this tenants created response has a 2xx status code
func (o *TenantsCreated) IsSuccess() bool {
	return true
}

// IsRedirect returns true when this tenants created response has a 3xx status code
func (o *TenantsCreated) IsRedirect() bool {
	return false
}

// IsClientError returns true when this tenants created response has a 4xx status code
func (o *TenantsCreated) IsClientError() bool {
	return false
}

// IsServerError returns true when this tenants created response has a 5xx status code
func (o *TenantsCreated) IsServerError() bool {
	return false
}

// IsCode returns true when this tenants created response a status code equal to that given
func (o *TenantsCreated) IsCode(code int) bool {
	return code == 201
}

// Code gets the status code for the tenants created response
func (o *TenantsCreated) Code() int {
	return 201
}

func (o *TenantsCreated) Error() string {
	return fmt.Sprintf("[POST /tenants][%d] tenantsCreated  %+v", 201, o.Payload)
}

func (o *TenantsCreated) String() string {
	return fmt.Sprintf("[POST /tenants][%d] tenantsCreated  %+v", 201, o.Payload)
}

func (o *TenantsCreated) GetPayload() *sfgate_models.SalesforcePostResponse {
	return o.Payload
}

func (o *TenantsCreated) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(sfgate_models.SalesforcePostResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewTenantsUnauthorized creates a TenantsUnauthorized with default headers values
func NewTenantsUnauthorized() *TenantsUnauthorized {
	return &TenantsUnauthorized{}
}

/*
TenantsUnauthorized describes a response with status code 401, with default header values.

Access unauthorized, invalid API-KEY was used
*/
type TenantsUnauthorized struct {
	Payload *sfgate_models.Error
}

// IsSuccess returns true when this tenants unauthorized response has a 2xx status code
func (o *TenantsUnauthorized) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this tenants unauthorized response has a 3xx status code
func (o *TenantsUnauthorized) IsRedirect() bool {
	return false
}

// IsClientError returns true when this tenants unauthorized response has a 4xx status code
func (o *TenantsUnauthorized) IsClientError() bool {
	return true
}

// IsServerError returns true when this tenants unauthorized response has a 5xx status code
func (o *TenantsUnauthorized) IsServerError() bool {
	return false
}

// IsCode returns true when this tenants unauthorized response a status code equal to that given
func (o *TenantsUnauthorized) IsCode(code int) bool {
	return code == 401
}

// Code gets the status code for the tenants unauthorized response
func (o *TenantsUnauthorized) Code() int {
	return 401
}

func (o *TenantsUnauthorized) Error() string {
	return fmt.Sprintf("[POST /tenants][%d] tenantsUnauthorized  %+v", 401, o.Payload)
}

func (o *TenantsUnauthorized) String() string {
	return fmt.Sprintf("[POST /tenants][%d] tenantsUnauthorized  %+v", 401, o.Payload)
}

func (o *TenantsUnauthorized) GetPayload() *sfgate_models.Error {
	return o.Payload
}

func (o *TenantsUnauthorized) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(sfgate_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewTenantsForbidden creates a TenantsForbidden with default headers values
func NewTenantsForbidden() *TenantsForbidden {
	return &TenantsForbidden{}
}

/*
TenantsForbidden describes a response with status code 403, with default header values.

Access forbidden, account lacks access
*/
type TenantsForbidden struct {
	Payload *sfgate_models.Error
}

// IsSuccess returns true when this tenants forbidden response has a 2xx status code
func (o *TenantsForbidden) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this tenants forbidden response has a 3xx status code
func (o *TenantsForbidden) IsRedirect() bool {
	return false
}

// IsClientError returns true when this tenants forbidden response has a 4xx status code
func (o *TenantsForbidden) IsClientError() bool {
	return true
}

// IsServerError returns true when this tenants forbidden response has a 5xx status code
func (o *TenantsForbidden) IsServerError() bool {
	return false
}

// IsCode returns true when this tenants forbidden response a status code equal to that given
func (o *TenantsForbidden) IsCode(code int) bool {
	return code == 403
}

// Code gets the status code for the tenants forbidden response
func (o *TenantsForbidden) Code() int {
	return 403
}

func (o *TenantsForbidden) Error() string {
	return fmt.Sprintf("[POST /tenants][%d] tenantsForbidden  %+v", 403, o.Payload)
}

func (o *TenantsForbidden) String() string {
	return fmt.Sprintf("[POST /tenants][%d] tenantsForbidden  %+v", 403, o.Payload)
}

func (o *TenantsForbidden) GetPayload() *sfgate_models.Error {
	return o.Payload
}

func (o *TenantsForbidden) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(sfgate_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewTenantsNotFound creates a TenantsNotFound with default headers values
func NewTenantsNotFound() *TenantsNotFound {
	return &TenantsNotFound{}
}

/*
TenantsNotFound describes a response with status code 404, with default header values.

Resource was not found
*/
type TenantsNotFound struct {
	Payload *sfgate_models.Error
}

// IsSuccess returns true when this tenants not found response has a 2xx status code
func (o *TenantsNotFound) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this tenants not found response has a 3xx status code
func (o *TenantsNotFound) IsRedirect() bool {
	return false
}

// IsClientError returns true when this tenants not found response has a 4xx status code
func (o *TenantsNotFound) IsClientError() bool {
	return true
}

// IsServerError returns true when this tenants not found response has a 5xx status code
func (o *TenantsNotFound) IsServerError() bool {
	return false
}

// IsCode returns true when this tenants not found response a status code equal to that given
func (o *TenantsNotFound) IsCode(code int) bool {
	return code == 404
}

// Code gets the status code for the tenants not found response
func (o *TenantsNotFound) Code() int {
	return 404
}

func (o *TenantsNotFound) Error() string {
	return fmt.Sprintf("[POST /tenants][%d] tenantsNotFound  %+v", 404, o.Payload)
}

func (o *TenantsNotFound) String() string {
	return fmt.Sprintf("[POST /tenants][%d] tenantsNotFound  %+v", 404, o.Payload)
}

func (o *TenantsNotFound) GetPayload() *sfgate_models.Error {
	return o.Payload
}

func (o *TenantsNotFound) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(sfgate_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewTenantsUnprocessableEntity creates a TenantsUnprocessableEntity with default headers values
func NewTenantsUnprocessableEntity() *TenantsUnprocessableEntity {
	return &TenantsUnprocessableEntity{}
}

/*
TenantsUnprocessableEntity describes a response with status code 422, with default header values.

Unprocessable Entity, likely a bad parameter
*/
type TenantsUnprocessableEntity struct {
	Payload *sfgate_models.Error
}

// IsSuccess returns true when this tenants unprocessable entity response has a 2xx status code
func (o *TenantsUnprocessableEntity) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this tenants unprocessable entity response has a 3xx status code
func (o *TenantsUnprocessableEntity) IsRedirect() bool {
	return false
}

// IsClientError returns true when this tenants unprocessable entity response has a 4xx status code
func (o *TenantsUnprocessableEntity) IsClientError() bool {
	return true
}

// IsServerError returns true when this tenants unprocessable entity response has a 5xx status code
func (o *TenantsUnprocessableEntity) IsServerError() bool {
	return false
}

// IsCode returns true when this tenants unprocessable entity response a status code equal to that given
func (o *TenantsUnprocessableEntity) IsCode(code int) bool {
	return code == 422
}

// Code gets the status code for the tenants unprocessable entity response
func (o *TenantsUnprocessableEntity) Code() int {
	return 422
}

func (o *TenantsUnprocessableEntity) Error() string {
	return fmt.Sprintf("[POST /tenants][%d] tenantsUnprocessableEntity  %+v", 422, o.Payload)
}

func (o *TenantsUnprocessableEntity) String() string {
	return fmt.Sprintf("[POST /tenants][%d] tenantsUnprocessableEntity  %+v", 422, o.Payload)
}

func (o *TenantsUnprocessableEntity) GetPayload() *sfgate_models.Error {
	return o.Payload
}

func (o *TenantsUnprocessableEntity) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(sfgate_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewTenantsInternalServerError creates a TenantsInternalServerError with default headers values
func NewTenantsInternalServerError() *TenantsInternalServerError {
	return &TenantsInternalServerError{}
}

/*
TenantsInternalServerError describes a response with status code 500, with default header values.

Server Internal Error
*/
type TenantsInternalServerError struct {
	Payload *sfgate_models.Error
}

// IsSuccess returns true when this tenants internal server error response has a 2xx status code
func (o *TenantsInternalServerError) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this tenants internal server error response has a 3xx status code
func (o *TenantsInternalServerError) IsRedirect() bool {
	return false
}

// IsClientError returns true when this tenants internal server error response has a 4xx status code
func (o *TenantsInternalServerError) IsClientError() bool {
	return false
}

// IsServerError returns true when this tenants internal server error response has a 5xx status code
func (o *TenantsInternalServerError) IsServerError() bool {
	return true
}

// IsCode returns true when this tenants internal server error response a status code equal to that given
func (o *TenantsInternalServerError) IsCode(code int) bool {
	return code == 500
}

// Code gets the status code for the tenants internal server error response
func (o *TenantsInternalServerError) Code() int {
	return 500
}

func (o *TenantsInternalServerError) Error() string {
	return fmt.Sprintf("[POST /tenants][%d] tenantsInternalServerError  %+v", 500, o.Payload)
}

func (o *TenantsInternalServerError) String() string {
	return fmt.Sprintf("[POST /tenants][%d] tenantsInternalServerError  %+v", 500, o.Payload)
}

func (o *TenantsInternalServerError) GetPayload() *sfgate_models.Error {
	return o.Payload
}

func (o *TenantsInternalServerError) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(sfgate_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
