// Code generated by go-swagger; DO NOT EDIT.

// (c) 2012-2023 by Vernon Keenan
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package sfgate_models

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
)

// ResearchProjectCompanyResponseMeta research project company response meta
//
// swagger:model researchProjectCompanyResponseMeta
type ResearchProjectCompanyResponseMeta struct {

	// Microservice Contact Info
	Contact string `json:"Contact,omitempty"`

	// Copyright Info
	Copyright string `json:"Copyright,omitempty"`

	// Account Number used for recording transactions
	ExternalAccount string `json:"ExternalAccount,omitempty"`

	// License Information and Restrictions
	License string `json:"License,omitempty"`

	// Operation ID
	OperationID string `json:"OperationID,omitempty"`

	// pagination
	Pagination *ResearchProjectCompanyResponseMetaPagination `json:"Pagination,omitempty"`

	// Request IP Address
	RequestIP string `json:"RequestIP,omitempty"`

	// Request Type
	RequestType string `json:"RequestType,omitempty"`

	// Request URL
	RequestURL string `json:"RequestURL,omitempty"`

	// Data Server Info
	ServerInfo string `json:"ServerInfo,omitempty"`

	// Data Server Response Time (ms)
	ServerResponseTime string `json:"ServerResponseTime,omitempty"`

	// Backend Server Timestamp
	ServerTimestamp string `json:"ServerTimestamp,omitempty"`
}

// Validate validates this research project company response meta
func (m *ResearchProjectCompanyResponseMeta) Validate(formats strfmt.Registry) error {
	var res []error

	if err := m.validatePagination(formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *ResearchProjectCompanyResponseMeta) validatePagination(formats strfmt.Registry) error {
	if swag.IsZero(m.Pagination) { // not required
		return nil
	}

	if m.Pagination != nil {
		if err := m.Pagination.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("Pagination")
			} else if ce, ok := err.(*errors.CompositeError); ok {
				return ce.ValidateName("Pagination")
			}
			return err
		}
	}

	return nil
}

// ContextValidate validate this research project company response meta based on the context it is used
func (m *ResearchProjectCompanyResponseMeta) ContextValidate(ctx context.Context, formats strfmt.Registry) error {
	var res []error

	if err := m.contextValidatePagination(ctx, formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *ResearchProjectCompanyResponseMeta) contextValidatePagination(ctx context.Context, formats strfmt.Registry) error {

	if m.Pagination != nil {
		if err := m.Pagination.ContextValidate(ctx, formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("Pagination")
			} else if ce, ok := err.(*errors.CompositeError); ok {
				return ce.ValidateName("Pagination")
			}
			return err
		}
	}

	return nil
}

// MarshalBinary interface implementation
func (m *ResearchProjectCompanyResponseMeta) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *ResearchProjectCompanyResponseMeta) UnmarshalBinary(b []byte) error {
	var res ResearchProjectCompanyResponseMeta
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}

// ResearchProjectCompanyResponseMetaPagination research project company response meta pagination
//
// swagger:model ResearchProjectCompanyResponseMetaPagination
type ResearchProjectCompanyResponseMetaPagination struct {

	// limit
	Limit int64 `json:"limit,omitempty"`

	// pagesize
	Pagesize int64 `json:"pagesize,omitempty"`

	// poffset
	Poffset int64 `json:"poffset,omitempty"`

	// setsize
	Setsize int64 `json:"setsize,omitempty"`
}

// Validate validates this research project company response meta pagination
func (m *ResearchProjectCompanyResponseMetaPagination) Validate(formats strfmt.Registry) error {
	return nil
}

// ContextValidate validates this research project company response meta pagination based on context it is used
func (m *ResearchProjectCompanyResponseMetaPagination) ContextValidate(ctx context.Context, formats strfmt.Registry) error {
	return nil
}

// MarshalBinary interface implementation
func (m *ResearchProjectCompanyResponseMetaPagination) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *ResearchProjectCompanyResponseMetaPagination) UnmarshalBinary(b []byte) error {
	var res ResearchProjectCompanyResponseMetaPagination
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}
